/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2008-2015 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011-2015 by FUJI SOFT INCORPORATED, JAPAN
 *  Copyright (C) 2011-2013 by Spansion LLC, USA
 *  Copyright (C) 2011-2015 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2011-2015 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2011-2014 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2011-2015 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2011-2015 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2011-2015 by Witz Corporation
 *  Copyright (C) 2014-2015 by AISIN COMCRUISE Co., Ltd., JAPAN
 *  Copyright (C) 2014-2015 by eSOL Co.,Ltd., JAPAN
 *  Copyright (C) 2014-2015 by SCSK Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: avalon_timer.c 1801 2015-03-27 06:34:43Z t_ishikawa $
 */

/*
 *		ޥɥ饤СAvalon Timer
 */

#include "kernel_impl.h"
#include "target_timer.h"
#include "avalon_timer.h"
#include "Os_Lcfg.h"

const uint32
target_sys_clk_timer_base_table[TotalNumberOfCores] = {
	SYS_CLK_TIMER_0_BASE,
#if TotalNumberOfCores > 1
	SYS_CLK_TIMER_1_BASE,
#endif /* TotalNumberOfCores > 1 */
#if TotalNumberOfCores > 2
	SYS_CLK_TIMER_2_BASE,
#endif /* TotalNumberOfCores > 2 */
#if TotalNumberOfCores > 3
	SYS_CLK_TIMER_3_BASE,
#endif /* TotalNumberOfCores > 3 */
};

const uint32
target_sys_clk_timer_intno_table[TotalNumberOfCores] = {
	INTNO_TIMER0,
#if TotalNumberOfCores > 1
	INTNO_TIMER1,
#endif /* TotalNumberOfCores > 1 */
#if TotalNumberOfCores > 2
	INTNO_TIMER2,
#endif /* TotalNumberOfCores > 2 */
#if TotalNumberOfCores > 3
	INTNO_TIMER3,
#endif /* TotalNumberOfCores > 3 */
};


/*
 *  ߤΥƥñ: ߥá
 *
 *  ̩ˤϡΥƥåΥƥ
 */
static SystemTimeMsType current_time[TotalNumberOfCores];

/*
 *  ޥñ̤Ǥλ
 *  ޡȥ쥹μ֤1msʤͤȤʤ
 */
SystemTimeUsType
get_tim_utime(void)
{
	SystemTimeUsType	utime;
	SystemTimeMsType	mtime;
	TickType			clock1, clock2;
	boolean				ireq;
	SIL_PRE_LOC;

	SIL_LOC_INT();
	mtime = current_time[x_core_id()];
	clock1 = target_timer_get_current();
	ireq = target_timer_probe_int();
	clock2 = target_timer_get_current();
	SIL_UNL_INT();
	utime = ((SystemTimeUsType) mtime) * 1000U;

	if ((ireq != FALSE) && (clock2 >= clock1)) {
		utime += 1000U;
	}
	utime += TO_USEC(clock1);
	return(utime);
}

/*
 *  100ʥñ̤Ǥλ
 */
SystemTime100NsType
get_tim_100ntime(void)
{
	SystemTime100NsType	ntime;
	SystemTimeMsType	mtime;
	TickType			clock1, clock2;
	boolean				ireq;
	SIL_PRE_LOC;

	SIL_LOC_INT();
	mtime = current_time[x_core_id()];
	clock1 = target_timer_get_current();
	ireq = target_timer_probe_int();
	clock2 = target_timer_get_current();
	SIL_UNL_INT();
	ntime = ((SystemTime100NsType) mtime) * 10000U;

	if ((ireq != FALSE) && (clock2 >= clock1)) {
		ntime += 10000U;
	}
	ntime += TO_100NSEC(clock1);
	return(ntime);
}

/*
 *  ޤεư
 */
void
target_timer_initialize(void)
{
	uint32 base = target_sys_clk_timer_base_table[x_core_id()];

	current_time[x_core_id()] = 0U;

	/* ޡȥå */
	sil_wrw_iop((void *) (base + AVALON_TIM_CONTROL), AVALON_TIM_CONTROL_STOP);
	/* ॢȥơꥢ */
	sil_wrw_iop((void *) (base + AVALON_TIM_STATUS), 0x00U);

	sil_wrw_iop((void *) (base + AVALON_TIM_PERIODL), ((TIMER_CLOCK - 1) & 0xffffU));           /* 󥿡å 16bit */
	sil_wrw_iop((void *) (base + AVALON_TIM_PERIODH), ((uint32) (TIMER_CLOCK - 1) >> 16));      /* 󥿡å 16bit */

	/*
	 * ޡȡȥɡߵ
	 */
	sil_wrw_iop((void *) (base + AVALON_TIM_CONTROL), AVALON_TIM_CONTROL_START
				| AVALON_TIM_CONTROL_CONT | AVALON_TIM_CONTROL_ITO);
}

/*
 *  ޤ߽
 */
void
target_timer_terminate(void)
{
	uint32 base = target_sys_clk_timer_base_table[x_core_id()];

	/*  */
	sil_wrw_iop((void *) (base + AVALON_TIM_CONTROL), AVALON_TIM_CONTROL_STOP);

	/* ׵Υꥢ */
	sil_wrw_iop((void *) (base + AVALON_TIM_STATUS), 0x00U);
}

/*
 *  target_timer_core0.arxmlѤʤн
 */
#ifndef SysTimerCnt0
#define SysTimerCnt0		UINT_C(0)
#endif /* SysTimerCnt0 */

/*
 *  target_timer_core1.arxmlѤʤн
 */
#ifndef SysTimerCnt1
#define SysTimerCnt1		UINT_C(1)
#endif /* SysTimerCnt1 */

/*
 *  ޳ߥϥɥζ̽
 */
LOCAL_INLINE void
target_timer_handler(CounterType cntid, CoreIdType coreid)
{
	StatusType	ercd;
	uint32		base = target_sys_clk_timer_base_table[coreid];

	/* TOӥåȤΥꥢ */
	sil_wrw_iop((void *) (base + AVALON_TIM_STATUS), 0x00U);

	/* current_time򹹿 */
	current_time[coreid]++;

	/*
	 *  󥿲ûν¹
	 */
	ercd = IncrementCounter(cntid);
	/* 顼꥿ξϥåȥ */
	if (ercd != E_OK) {
		ShutdownAllCores(ercd);
	}
}

/*
 *  ޳ߥϥɥ
 */
ISR(target_timer_hdr0)
{
	target_timer_handler(SysTimerCnt0, 0U);
}

ISR(target_timer_hdr1)
{
	target_timer_handler(SysTimerCnt1, 1U);
}
