/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2008-2015 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011-2015 by FUJI SOFT INCORPORATED, JAPAN
 *  Copyright (C) 2011-2013 by Spansion LLC, USA
 *  Copyright (C) 2011-2015 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2011-2015 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2011-2014 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2011-2015 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2011-2015 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2011-2015 by Witz Corporation
 *  Copyright (C) 2014-2015 by AISIN COMCRUISE Co., Ltd., JAPAN
 *  Copyright (C) 2014-2015 by eSOL Co.,Ltd., JAPAN
 *  Copyright (C) 2014-2015 by SCSK Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: nios2.h 1801 2015-03-27 06:34:43Z t_ishikawa $
 */

/*
 *		Nios2Υϡɥ񸻤
 */

#ifndef TOPPERS_NIOS2_H
#define TOPPERS_NIOS2_H

/*
 *  status쥸ΥӥåȥեɤΥޥ
 */
#define STATUS_U	UINT_C(0x02)
#define STATUS_PIE	UINT_C(0x01)
#define STATUS_IL	UINT_C(0x3f0)

/*
 *  status쥸ΥӥåȥեɤΥեå
 */
#define STATUS_IL_OFFSET	4


/*
 * SYSID
 */
#define SYSVER_REG1	(SYSVER_BASE + UINT_C(0x00))
#define SYSVER_REG2	(SYSVER_BASE + UINT_C(0x04))
#define SYSVER_REG3	(SYSVER_BASE + UINT_C(0x08))
#define SYSVER_REG4	(SYSVER_BASE + UINT_C(0x0C))
#define SYSVER_REG5	(SYSVER_BASE + UINT_C(0x10))
#define SYSVER_REG6	(SYSVER_BASE + UINT_C(0x14))
#define SYSVER_REG7	(SYSVER_BASE + UINT_C(0x18))
#define SYSVER_REG8	(SYSVER_BASE + UINT_C(0x1C))
#define MAGIC_START	UINT_C(0x87654321) /* ƱѤΥޥåʥС */

/*
 *	MutexϢ
 */

#define MUTEX_MUTEX_OFFSET	UINT_C(0x00)
#define MUTEX_RESET_OFFSET	UINT_C(0x04)

#define MUTEX_MUTEX_OWNER_MASK		UINT_C(0xffff0000)
#define MUTEX_MUTEX_VALUE_MASK		UINT_C(0x0000ffff)
#define MUTEX_MUTEX_OWNER_OFFSET	UINT_C(16)

#define MUTEX_RESET_RESET_MASK		UINT_C(0x01)
#define MUTEX_VALUE_DATA			UINT_C(0x1234)

#ifndef TOPPERS_MACRO_ONLY
#include "prc_insn.h"
#include "prc_sil.h"

/*
 *  ID0ꥸˤμ
 *  CCBɥ쥹ꤵƤ롥
 */
LOCAL_INLINE CoreIdType
x_core_id(void)
{
	return((CoreIdType) ((current_cpuid() >> 20) & 0xfU));
}

/*
 *  Mutexν
 */
LOCAL_INLINE void
nios2_mutex_init_lock(uint32 base)
{
	uint32	data;
	uint32	check;

	check = sil_rew_iop((void *) (base + MUTEX_RESET_OFFSET));

	if (check == MUTEX_RESET_RESET_MASK) {
		sil_wrw_iop((void *) (base + MUTEX_RESET_OFFSET), MUTEX_RESET_RESET_MASK);
	}
	else {
		data = sil_rew_iop((void *) (base + MUTEX_MUTEX_OFFSET));
		sil_wrw_iop((void *) (base + MUTEX_MUTEX_OFFSET), (data & MUTEX_MUTEX_OWNER_MASK));
	}
}

/*
 *  Mutexμ
 *  ǤtrueǤʤfalse֤
 */
LOCAL_INLINE boolean
nios2_mutex_try_lock(uint32 base, CoreIdType coreid)
{
	uint32	data;
	uint32	check;

	data = ((uint32) coreid << MUTEX_MUTEX_OWNER_OFFSET) | MUTEX_VALUE_DATA;

	sil_wrw_iop((void *) (base + MUTEX_MUTEX_OFFSET), data);
	check = sil_rew_iop((void *) (base + MUTEX_MUTEX_OFFSET));

	return((data == check) ? TRUE : FALSE);
}

/*
 *  Mutexβ
 */
LOCAL_INLINE void
nios2_mutex_release_lock(uint32 base, CoreIdType coreid)
{
	sil_wrw_iop((void *) (base + MUTEX_MUTEX_OFFSET), ((uint32) coreid << MUTEX_MUTEX_OWNER_OFFSET));
}

#endif /* TOPPERS_MACRO_ONLY */


#endif /* TOPPERS_NIOS2_H */
