/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2008-2015 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2012-2015 by FUJI SOFT INCORPORATED, JAPAN
 *  Copyright (C) 2012-2013 by Spansion LLC, USA
 *  Copyright (C) 2012-2015 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2012-2015 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2012-2014 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2012-2015 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2012-2015 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2012-2015 by Witz Corporation
 *  Copyright (C) 2014-2015 by AISIN COMCRUISE Co., Ltd., JAPAN
 *  Copyright (C) 2014-2015 by eSOL Co.,Ltd., JAPAN
 *  Copyright (C) 2014-2015 by SCSK Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: prc_ccb.h 1801 2015-03-27 06:34:43Z t_ishikawa $
 */

/*
 *  ץå¸֥åNios2ѡ
 */
#ifndef TOPPERS_PRC_CCB_H
#define TOPPERS_PRC_CCB_H

#include "nios2.h"

#ifndef TOPPERS_MACRO_ONLY

/*
 *	ͥ¾Υԥå
 */
/*
 *  åη
 */
typedef uint32 LockType;

/*
 *  
 */
typedef struct core_control_block CCB;

/*
 *  åȰ¸ ȥ֥å(Nios2)
 */
typedef struct target_core_control_block {
	/*
	 *  㳰ʳ/CPU㳰ˤΥͥȲΥ
	 *  ƥȻȤΤ˻
	 */
	uint32 except_nest_cnt;

	uint32	exception_temporary1;
	uint32	exception_temporary2;

	/*
	 * եå롼¹ԤΥƥॹåΥåݥ
	 */
	uint32	hook_savedsp;
	uint32	shutdown_hook_savedsp;
	uint32	trusted_hook_savedsp;
	/*
	 *  MPUꤷƤ륹åͭ륿TCB
	 */
	void *p_ctxstk;
	/*
	 *  MPUꤷƤOSAP
	 */
	void *p_ctxosap;

	/*
	 *  x_nested_lock_os_int()ΥͥȲ
	 *  νѲʤ褦volatile 
	 */
	volatile uint8 nested_lock_os_int_cnt;

	/*
	 *  OS߶ػ߾֤λ˳ͥ٥ޥ¸ѿ
	 */
	volatile uint32	saved_status_il;
} TCCB;

/*
 *  get_my_p_ccb򥿡åȰ¸
 */
#define OMIT_GET_MY_P_CCB
/*
 *  CCBɥ쥹μ
 *  CCBɥ쥹ꤵƤ롥
 */
LOCAL_INLINE CCB *
get_my_p_ccb(void)
{
	return((CCB *) current_cpuid());
}


#endif /* TOPPERS_MACRO_ONLY */
#endif /* TOPPERS_PRC_CCB_H */
