/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2008-2015 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011-2015 by FUJI SOFT INCORPORATED, JAPAN
 *  Copyright (C) 2011-2013 by Spansion LLC, USA
 *  Copyright (C) 2011-2015 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2011-2015 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2011-2014 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2011-2015 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2011-2015 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2011-2015 by Witz Corporation
 *  Copyright (C) 2014-2015 by AISIN COMCRUISE Co., Ltd., JAPAN
 *  Copyright (C) 2014-2015 by eSOL Co.,Ltd., JAPAN
 *  Copyright (C) 2014-2015 by SCSK Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: prc_sil.h 1801 2015-03-27 06:34:43Z t_ishikawa $
 */

/*
 *		ڤӼեɥ쥹Υץå¸Nios2ѡ
 */

#ifndef TOPPERS_PRC_SIL_H
#define TOPPERS_PRC_SIL_H

#include "nios2_system.h"

/*
 *  ץåΥǥ
 */
#define SIL_ENDIAN_LITTLE

/*
 *	MutexϢ
 */
#define SIL_MUTEX_MUTEX_OFFSET			UINT_C(0x00)
#define SIL_MUTEX_MUTEX_OWNER_OFFSET	UINT_C(16)
#define SIL_MUTEX_VALUE_DATA			UINT_C(0x1234)
#define SIL_MUTEX_RESET_RESET_MASK		UINT_C(0x01)
#define SIL_MUTEX_RESET_OFFSET			UINT_C(0x04)
#define SIL_MUTEX_MUTEX_OWNER_MASK		UINT_C(0xffff0000)

#ifndef TOPPERS_MACRO_ONLY

/*
 *  NMI٤Ƥγߤζػ
 */
LOCAL_INLINE uint8
TOPPERS_disint(void)
{
	uint32 TOPPERS_status;

	Asm("rdctl %0, status" : "=r" (TOPPERS_status));
	Asm("wrctl status, %0" :: "r" (TOPPERS_status & (~(0x0001U))) : "memory");
	return((uint8) (TOPPERS_status & (0x0001U)));
}

/*
 *  ͥ٥ޥɽˤθͤ
 */
LOCAL_INLINE void
TOPPERS_set_pie(uint8 TOPPERS_pie_bit)
{
	uint32 TOPPERS_status;

	Asm("rdctl %0, status" : "=r" (TOPPERS_status));
	TOPPERS_status = TOPPERS_status & (~(0x0001U));
	TOPPERS_status = TOPPERS_status | ((uint32) TOPPERS_pie_bit & (0x0001U));
	Asm("wrctl status, %0" :: "r" (TOPPERS_status) : "memory");
}

/*
 *  I/O֥ؿ
 *  Nios2I/O֤ȥ֤϶̤ʤå̵ˤ뤿ᡤ
 *  I/OϤδؿѤ뤳ȤȤ
 */

/*
 *  32ӥåñ̤ɽФ
 */
LOCAL_INLINE uint32
sil_rew_iop(void *mem)
{
	return((uint32) __builtin_ldwio(mem));
}

LOCAL_INLINE void
sil_wrw_iop(void *mem, uint32 data)
{
	__builtin_stwio(mem, data);
}

/*
 *  IDμ
 */
LOCAL_INLINE uint32
sil_get_coreid(void)
{
	uint32 status;

	Asm("rdctl %0, cpuid" : "=r" (status));

	return((status >> 20) & 0x000000fU);
}

/*
 *  ߶ػߤȼԥåμ
 */
LOCAL_INLINE uint8
TOPPERS_spn_lock(void)
{
	uint32			data;
	uint32			check;
	volatile uint8	status;

	data = (sil_get_coreid() << SIL_MUTEX_MUTEX_OWNER_OFFSET) | SIL_MUTEX_VALUE_DATA;

  retry:
	/* ߾֤塤ػ߾֤ */
	status = TOPPERS_disint();
	sil_wrw_iop((void *) (SIL_MUTEX_BASE + SIL_MUTEX_MUTEX_OFFSET), data);
	check = sil_rew_iop((void *) (SIL_MUTEX_BASE + SIL_MUTEX_MUTEX_OFFSET));

	if (data != check) {
		/* ԥåǤʤä */
		/* ߾֤ξ֤ */
		TOPPERS_set_pie(status);
		goto retry;
	}

	Asm("" ::: "memory");

	return(status);
}

/*
 *  ԥåֵ
 */
LOCAL_INLINE void
TOPPERS_spn_unlock(uint8 status)
{
	sil_wrw_iop((void *) (SIL_MUTEX_BASE + SIL_MUTEX_MUTEX_OFFSET),
				(sil_get_coreid() << SIL_MUTEX_MUTEX_OWNER_OFFSET));

	/* ԥåμγߤζػ߾֤ */
	TOPPERS_set_pie(status);
}

/*
 *  ߥå֤
 */
#define SIL_PRE_LOC		uint8 TOPPERS_pie_bit
#define SIL_LOC_INT()	(TOPPERS_pie_bit = TOPPERS_disint())
#define SIL_UNL_INT()	(TOPPERS_set_pie(TOPPERS_pie_bit))
#define SIL_LOC_SPN()	(TOPPERS_pie_bit = TOPPERS_spn_lock())
#define SIL_UNL_SPN()	(TOPPERS_spn_unlock(TOPPERS_pie_bit))

#endif /* TOPPERS_MACRO_ONLY */

#endif /* TOPPERS_PRC_SIL_H */
