/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2015 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011-2015 by FUJI SOFT INCORPORATED, JAPAN
 *  Copyright (C) 2011-2013 by Spansion LLC, USA
 *  Copyright (C) 2011-2015 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2011-2015 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2011-2014 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2011-2015 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2011-2015 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2011-2015 by Witz Corporation
 *  Copyright (C) 2014-2015 by AISIN COMCRUISE Co., Ltd., JAPAN
 *  Copyright (C) 2014-2015 by eSOL Co.,Ltd., JAPAN
 *  Copyright (C) 2014-2015 by SCSK Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: prc_svc.h 1801 2015-03-27 06:34:43Z t_ishikawa $
 */

#ifndef TOPPERS_PRC_SVC_H
#define TOPPERS_PRC_SVC_H

#ifndef TOPPERS_MACRO_ONLY
typedef sint32 FunctionCodeType;                  /* ǽ */
#endif /* TOPPERS_MACRO_ONLY */

/*
 *		ͥΥӥΥ󥿥ե
 *
 *  AUTOSAR OS Nios2ѥ󥿥ե
 *  å쥸
 *    r1 : GCC Nios2Υ󥰥٥󥷥atAssembler Tempolaryˤ
 *         쥸
 *
 *  ѥ᡼Ϥ쥸
 *    Nios2٥󥷥Ǥϡѥ᡼ĤޤǤǤ r4,r5,r6,r7
 *   Ѥƥ쥸ϤȤƤ롥ѥ᡼İʾξϡĤ
 *   Υѥ᡼饹åϤȤʤ
 *
 *  AUTOSAR OS ΥӥΥѥ᡼Ϻ磳ĤʤΤǡä˹θʤ
 *  r4ʤɤΰ˻Ѥ쥸˲뤳Ȥ狼äΤ˲ꥹ
 *  ˲ä
 *
 *  ӥΥ꥿
 *   Nios2٥󥷥Ǥϴؿͤr2/r3˳Ǽ
 *    32bitޤǤ r2 ΤߤȤ32bit 礭ͤ r2/r3 Ѥ
 *    ӥϰϤǤr2Τ߻Ѥ
 *
 *  GCCγĥ֥깽ʸ
 *   asm(֥ƥץ졼
 *       : ϥڥ
 *       : ϥڥ
 *       : ˲쥸Υꥹ
 *   )
 *
 */

#define CAL_SVC_0M(TYPE, FNCD)																					   \
	register FunctionCodeType r2 asm ("r2") = (FunctionCodeType) (FNCD);										   \
	Asm (																										   \
		"trap \n\t"																								   \
		: "=r" (r2)																								   \
		: "r" (r2)																								   \
		: "ra", "at", "r3", "r4", "r5", "r6", "r7", "r8", "r9", "r10", "r11", "r12", "r13", "r14", "r15", "memory" \
		);																										   \
	return ((TYPE) r2)


#define CAL_SVC_1M(TYPE, FNCD, TYPE1, PAR1)																	 \
	register FunctionCodeType r2 asm ("r2") = (FunctionCodeType) (FNCD);									 \
	register TYPE1	r4 asm ("r4") = (TYPE1) (PAR1);															 \
	Asm (																									 \
		"trap \n\t"																							 \
		: "=r" (r2), "=r" (r4)																				 \
		: "r" (r2), "r" (r4)																				 \
		: "ra", "at", "r3", "r5", "r6", "r7", "r8", "r9", "r10", "r11", "r12", "r13", "r14", "r15", "memory" \
		);																									 \
	return ((TYPE) r2)

#define CAL_SVC_2M(TYPE, FNCD, TYPE1, PAR1, TYPE2, PAR2)											   \
	register FunctionCodeType r2 asm ("r2") = (FunctionCodeType) (FNCD);							   \
	register TYPE1	r4 asm ("r4") = (TYPE1) (PAR1);													   \
	register TYPE2	r5 asm ("r5") = (TYPE2) (PAR2);													   \
	Asm (																							   \
		"trap \n\t"																					   \
		: "=r" (r2), "=r" (r4), "=r" (r5)															   \
		: "r" (r2), "r" (r4), "r" (r5)																   \
		: "ra", "at", "r3", "r6", "r7", "r8", "r9", "r10", "r11", "r12", "r13", "r14", "r15", "memory" \
		);																							   \
	return ((TYPE) r2)

#define CAL_SVC_3M(TYPE, FNCD, TYPE1, PAR1,														 \
				   TYPE2, PAR2, TYPE3, PAR3)													 \
	register FunctionCodeType r2 asm ("r2") = (FunctionCodeType) (FNCD);						 \
	register TYPE1	r4 asm ("r4") = (TYPE1) (PAR1);												 \
	register TYPE2	r5 asm ("r5") = (TYPE2) (PAR2);												 \
	register TYPE3	r6 asm ("r6") = (TYPE3) (PAR3);												 \
	Asm (																						 \
		"trap \n\t"																				 \
		: "=r" (r2), "=r" (r4), "=r" (r5), "=r" (r6)											 \
		: "r" (r2), "r" (r4), "r" (r5), "r" (r6)												 \
		: "ra", "at", "r3", "r7", "r8", "r9", "r10", "r11", "r12", "r13", "r14", "r15", "memory" \
		);																						 \
	return ((TYPE) r2)


/* ʲ void к */

#define CAL_SVC_0N(TYPE, FNCD)																					   \
	register FunctionCodeType r2 asm ("r2") = (FunctionCodeType) (FNCD);										   \
	Asm (																										   \
		"trap \n\t"																								   \
		: "=r" (r2)																								   \
		: "r" (r2)																								   \
		: "ra", "at", "r3", "r4", "r5", "r6", "r7", "r8", "r9", "r10", "r11", "r12", "r13", "r14", "r15", "memory" \
		)

#define CAL_SVC_1N(TYPE, FNCD, TYPE1, PAR1)																	 \
	register FunctionCodeType r2 asm ("r2") = (FunctionCodeType) (FNCD);									 \
	register TYPE1	r4 asm ("r4") = (TYPE1) (PAR1);															 \
	Asm (																									 \
		"trap \n\t"																							 \
		: "=r" (r2), "=r" (r4)																				 \
		: "r" (r2), "r" (r4)																				 \
		: "ra", "at", "r3", "r5", "r6", "r7", "r8", "r9", "r10", "r11", "r12", "r13", "r14", "r15", "memory" \
		)

#define CAL_SVC_2N(TYPE, FNCD, TYPE1, PAR1, TYPE2, PAR2)											   \
	register FunctionCodeType r2 asm ("r2") = (FunctionCodeType) (FNCD);							   \
	register TYPE1	r4 asm ("r4") = (TYPE1) (PAR1);													   \
	register TYPE2	r5 asm ("r5") = (TYPE2) (PAR2);													   \
	Asm (																							   \
		"trap \n\t"																					   \
		: "=r" (r2), "=r" (r4), "=r" (r5)															   \
		: "r" (r2), "r" (r4), "r" (r5)																   \
		: "ra", "at", "r3", "r6", "r7", "r8", "r9", "r10", "r11", "r12", "r13", "r14", "r15", "memory" \
		)

#define CAL_SVC_3N(TYPE, FNCD, TYPE1, PAR1,														 \
				   TYPE2, PAR2, TYPE3, PAR3)													 \
	register FunctionCodeType r2 asm ("r2") = (FunctionCodeType) (FNCD);						 \
	register TYPE1	r4 asm ("r4") = (TYPE1) (PAR1);												 \
	register TYPE2	r5 asm ("r5") = (TYPE2) (PAR2);												 \
	register TYPE3	r6 asm ("r6") = (TYPE3) (PAR3);												 \
	Asm (																						 \
		"trap \n\t"																				 \
		: "=r" (r2), "=r" (r4), "=r" (r5), "=r" (r6)											 \
		: "r" (r2), "r" (r4), "r" (r5), "r" (r6)												 \
		: "ra", "at", "r3", "r7", "r8", "r9", "r10", "r11", "r12", "r13", "r14", "r15", "memory" \
		)

#endif /* TOPPERS_PRC_SVC_H */
