/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2008-2015 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2012-2015 by FUJI SOFT INCORPORATED, JAPAN
 *  Copyright (C) 2012-2013 by Spansion LLC, USA
 *  Copyright (C) 2012-2015 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2012-2015 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2012-2014 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2012-2015 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2012-2015 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2012-2015 by Witz Corporation
 *  Copyright (C) 2014-2015 by AISIN COMCRUISE Co., Ltd., JAPAN
 *  Copyright (C) 2014-2015 by eSOL Co.,Ltd., JAPAN
 *  Copyright (C) 2014-2015 by SCSK Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: prc_tas_lock.h 1801 2015-03-27 06:34:43Z t_ishikawa $
 */

/*
 *	OS¾Test&Setå⥸塼Nios2ѡ
 */

#ifndef TOPPERS_PRC_TAS_LOCK_H
#define TOPPERS_PRC_TAS_LOCK_H

#if TTYPE_KLOCK == G_KLOCK

/*
 *  㥤ȥåνG_KLOCKξ
 */
LOCAL_INLINE void
x_initialize_giant_lock(LockType *p_giant_lock)
{
	*p_giant_lock = GIANT_LOCK;
	nios2_mutex_init_lock(*p_giant_lock);
}

#endif /* TTYPE_KLOCK == G_KLOCK */

#if TTYPE_KLOCK == C_KLOCK

/*
 *  åΥơ֥
 *  åȰ¸
 */
extern const uint32	target_tsk_lock_table[];

/*
 *  åνC_KLOCKξ
 */
LOCAL_INLINE void
x_initialize_tsk_lock(LockType *p_tsk_lock)
{
	*p_tsk_lock = target_tsk_lock_table[x_core_id()];
	nios2_mutex_init_lock(*p_tsk_lock);
}

/*
 *  󥿥åΥơ֥
 *  åȰ¸
 */
extern const uint32	target_cnt_lock_table[];

/*
 *  󥿥åν
 */
LOCAL_INLINE void
x_initialize_cnt_lock(LockType *p_cnt_lock)
{
	*p_cnt_lock = target_cnt_lock_table[x_core_id()];
	nios2_mutex_init_lock(*p_cnt_lock);
}

/*
 *  ԥååν
 */
LOCAL_INLINE void
x_initialize_spn_lock(LockType *p_spn_lock)
{
	*p_spn_lock = SPN_LOCK;
	nios2_mutex_init_lock(*p_spn_lock);
}

/*
 *  IOCåν
 */
LOCAL_INLINE void
x_initialize_ioc_lock(LockType *p_ioc_lock)
{
	*p_ioc_lock = IOC_LOCK;
	nios2_mutex_init_lock(*p_ioc_lock);
}

#endif /* TTYPE_KLOCK == C_KLOCK */


/*
 *  åؿ
 */

/*
 *  1ܤΥåʥ󥿥ƥȶѡ
 */
LOCAL_INLINE void
x_acquire_lock(const LockType *p_lock)
{
	CoreIdType coreid = x_core_id();

	while (1) {
		if (nios2_mutex_try_lock(*p_lock, coreid) != FALSE) {
			/* å */
			Asm("" ::: "memory");
			return;
		}
		/* ߤĤ */
		x_nested_unlock_os_int();
		x_nested_lock_os_int();
	}
}

/*
 *  2ܤΥåʥ󥿥ƥȶѡ
 */
LOCAL_INLINE void
x_acquire_lock_with_os_int(const LockType *p_lock)
{
	CoreIdType coreid = x_core_id();

	while (1) {
		if (nios2_mutex_try_lock(*p_lock, coreid) != FALSE) {
			/* å */
			Asm("" ::: "memory");
			return;
		}
	}
}

/*
 *  åβʥ󥿥ƥȶѡ
 */
LOCAL_INLINE void
x_release_lock(const LockType *p_lock)
{
	Asm("" ::: "memory");
	nios2_mutex_release_lock(*p_lock, x_core_id());
}

/*
 *  åμԡʥ󥿥ƥȶѡ
 */
LOCAL_INLINE boolean
x_try_lock(const LockType *p_lock)
{
	if (nios2_mutex_try_lock(*p_lock, x_core_id()) != FALSE) {
		/* å */
		Asm("" ::: "memory");
		return(TRUE);
	}
	return(FALSE);
}

#endif /* TOPPERS_PRC_TAS_LOCK_H */
