/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2015 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011-2015 by FUJI SOFT INCORPORATED, JAPAN
 *  Copyright (C) 2011-2013 by Spansion LLC, USA
 *  Copyright (C) 2011-2015 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2011-2015 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2011-2014 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2011-2015 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2011-2015 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2004-2015 by Witz Corporation
 *  Copyright (C) 2014-2015 by AISIN COMCRUISE Co., Ltd., JAPAN
 *  Copyright (C) 2014-2015 by eSOL Co.,Ltd., JAPAN
 *  Copyright (C) 2014-2015 by SCSK Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: counter_manage.c 1801 2015-03-27 06:34:43Z t_ishikawa $
 */

/*
 *		󥿴⥸塼
 */

#include "kernel_impl.h"
#include "check.h"
#include "counter.h"
#include "mc.h"

/*
 *  ȥ졼ޥΥǥե
 */
#ifndef LOG_INCCNT_ENTER
#define LOG_INCCNT_ENTER(cntid)
#endif /* LOG_INCCNT_ENTER */

#ifndef LOG_INCCNT_LEAVE
#define LOG_INCCNT_LEAVE(ercd)
#endif /* LOG_INCCNT_LEAVE */

#ifndef LOG_GETCNT_ENTER
#define LOG_GETCNT_ENTER(cntid)
#endif /* LOG_GETCNT_ENTER */

#ifndef LOG_GETCNT_LEAVE
#define LOG_GETCNT_LEAVE(ercd, p_val)
#endif /* LOG_GETCNT_LEAVE */

#ifndef LOG_GETEPS_ENTER
#define LOG_GETEPS_ENTER(cntid, p_val)
#endif /* LOG_GETEPS_ENTER */

#ifndef LOG_GETEPS_LEAVE
#define LOG_GETEPS_LEAVE(ercd, p_val, p_eval)
#endif /* LOG_GETEPS_LEAVE */

/*
 *  󥿤Υ󥯥
 */
#ifdef TOPPERS_IncrementCounter

StatusType
IncrementCounter(CounterType CounterID)
{
	StatusType	ercd = E_OK;
	CNTCB		*p_cntcb;
	OSAPCB		*p_osapcb;

	CHECK_DISABLEDINT();
	CHECK_CALLEVEL(CALLEVEL_INCREMENTCOUNTER);
	CHECK_ID(CounterID < tnum_counter);
	CHECK_ID(CounterID >= tnum_hardcounter);
	p_cntcb = get_cntcb(CounterID);
	CHECK_CORE(p_cntcb->p_cntinib != NULL);
	CHECK_CORE(p_cntcb->p_cntinib->coreid == x_core_id());
	CHECK_RIGHT(p_cntcb->p_cntinib->acsbtmp);

	p_osapcb = p_cntcb->p_cntinib->p_osapcb;
	x_nested_lock_os_int();

	/* 󥿽°OSAPξ֤å */
	D_CHECK_ACCESS((p_osapcb->osap_stat == APPLICATION_ACCESSIBLE) ||
				   ((p_osapcb->osap_stat == APPLICATION_RESTARTING) &&
					(p_osapcb == get_my_p_ccb()->p_runosap)));

	/*
	 *  󥿤Υ󥯥
	 *  顼ξincr_counter_processǥ顼եåƤӽФƤΤǡ
	 *  Ǥϡ顼եåƤӽФʤ
	 */
	ercd = incr_counter_process(p_cntcb, CounterID);

  d_exit_no_errorhook:
	x_nested_unlock_os_int();
  exit_no_errorhook:
	return(ercd);

#ifdef CFG_USE_ERRORHOOK
  exit_errorhook:
	x_nested_lock_os_int();
  d_exit_errorhook:
#ifdef CFG_USE_PARAMETERACCESS
	get_my_p_ccb()->_errorhook_par1.cntid = CounterID;
#endif /* CFG_USE_PARAMETERACCESS */
	call_errorhook(ercd, OSServiceId_IncrementCounter);
	goto d_exit_no_errorhook;
#endif /* CFG_USE_ERRORHOOK */
}

#endif /* TOPPERS_IncrementCounter */

/*
 *  ͤλ
 */
#ifdef TOPPERS_GetCounterValue

StatusType
GetCounterValue(CounterType CounterID, TickRefType Value)
{
	StatusType	ercd = E_OK;
	CNTCB		*p_cntcb;
	TickType	curval;
	OSAPCB		*p_osapcb;
	CCB			*p_ccb;

	LOG_GETCNT_ENTER(CounterID);
	CHECK_DISABLEDINT();
	CHECK_CALLEVEL(CALLEVEL_GETCOUNTERVALUE);
	CHECK_ID(CounterID < tnum_counter);
	CHECK_PARAM_POINTER(Value);
	CHECK_MEM_WRITE(Value, TickType);
	p_cntcb = get_cntcb(CounterID);
	CHECK_CORE(p_cntcb->p_cntinib != NULL);
	CHECK_RIGHT(p_cntcb->p_cntinib->acsbtmp);

	p_osapcb = p_cntcb->p_cntinib->p_osapcb;
	p_ccb = get_p_ccb(p_cntcb->p_cntinib->coreid);
	/*
	 *  Τᡤե졼ͤΣܡܣޤǥ
	 *  åפΤǥͤͤ礭ͤ򸺻
	 *
	 *  *Value ľƤ褤,ɽѿ쥸˳Ƥ뤳
	 *  ˤ®٤ԤƤ
	 */
	x_nested_lock_os_int();
	acquire_cnt_lock(p_ccb);

	/* 󥿽°OSAPξ֤å */
	D_CHECK_ACCESS((p_osapcb->osap_stat == APPLICATION_ACCESSIBLE) ||
				   ((p_osapcb->osap_stat == APPLICATION_RESTARTING) &&
					(p_osapcb == get_my_p_ccb()->p_runosap)));

	curval = get_curval(p_cntcb, CounterID);
	release_cnt_lock(p_ccb);
	x_nested_unlock_os_int();

	if (curval > p_cntcb->p_cntinib->maxval) {
		curval -= (p_cntcb->p_cntinib->maxval + 1U);
	}
	*Value = curval;

  exit_no_errorhook:
	LOG_GETCNT_LEAVE(ercd, Value);
	return(ercd);

#ifdef CFG_USE_ERRORHOOK
  d_exit_errorhook:
	release_cnt_lock(p_ccb);
	goto errorhook_start;

  exit_errorhook:
	x_nested_lock_os_int();
  errorhook_start:
#ifdef CFG_USE_PARAMETERACCESS
	get_my_p_ccb()->_errorhook_par1.cntid = CounterID;
	get_my_p_ccb()->_errorhook_par2.p_val = Value;
#endif /* CFG_USE_PARAMETERACCESS */
	call_errorhook(ercd, OSServiceId_GetCounterValue);
#else /* CFG_USE_ERRORHOOK */
  d_exit_no_errorhook:
	release_cnt_lock(p_ccb);
#endif /* CFG_USE_ERRORHOOK */
	x_nested_unlock_os_int();
	goto exit_no_errorhook;
}

#endif /* TOPPERS_GetCounterValue */

/*
 *  вᥫͤλ
 */
#ifdef TOPPERS_GetElapsedValue

StatusType
GetElapsedValue(CounterType CounterID, TickRefType Value, TickRefType ElapsedValue)
{
	StatusType	ercd = E_OK;
	CNTCB		*p_cntcb;
	TickType	curval;
	OSAPCB		*p_osapcb;
	CCB			*p_ccb;

	LOG_GETEPS_ENTER(CounterID, Value);
	CHECK_DISABLEDINT();
	CHECK_CALLEVEL(CALLEVEL_GETELAPSEDVALUE);
	CHECK_ID(CounterID < tnum_counter);
	CHECK_PARAM_POINTER(Value);
	CHECK_PARAM_POINTER(ElapsedValue);
	CHECK_MEM_RW(Value,  TickType);
	CHECK_MEM_WRITE(ElapsedValue, TickType);
	p_cntcb = get_cntcb(CounterID);
	CHECK_CORE(p_cntcb->p_cntinib != NULL);
	CHECK_RIGHT(p_cntcb->p_cntinib->acsbtmp);

	CHECK_VALUE(*Value <= p_cntcb->p_cntinib->maxval);

	p_osapcb = p_cntcb->p_cntinib->p_osapcb;
	p_ccb = get_p_ccb(p_cntcb->p_cntinib->coreid);
	/*
	 *  Τᡤե졼ͤΣܡܣޤǥ
	 *  åפΤǥͤͤ礭ͤ򸺻
	 */
	x_nested_lock_os_int();
	acquire_cnt_lock(p_ccb);

	/* 󥿽°OSAPξ֤å */
	D_CHECK_ACCESS((p_osapcb->osap_stat == APPLICATION_ACCESSIBLE) ||
				   ((p_osapcb->osap_stat == APPLICATION_RESTARTING) &&
					(p_osapcb == get_my_p_ccb()->p_runosap)));

	curval = get_curval(p_cntcb, CounterID);
	release_cnt_lock(p_ccb);
	x_nested_unlock_os_int();

	if (curval > p_cntcb->p_cntinib->maxval) {
		curval -= (p_cntcb->p_cntinib->maxval + 1U);
	}
	*ElapsedValue = diff_tick(curval, *Value, p_cntcb->p_cntinib->maxval);
	*Value = curval;

  exit_no_errorhook:
	LOG_GETEPS_LEAVE(ercd, Value, ElapsedValue);
	return(ercd);

#ifdef CFG_USE_ERRORHOOK
  d_exit_errorhook:
	release_cnt_lock(p_ccb);
	goto errorhook_start;

  exit_errorhook:
	x_nested_lock_os_int();
  errorhook_start:
#ifdef CFG_USE_PARAMETERACCESS
	get_my_p_ccb()->_errorhook_par1.cntid = CounterID;
	get_my_p_ccb()->_errorhook_par2.p_val = Value;
	get_my_p_ccb()->_errorhook_par3.p_eval = ElapsedValue;
#endif /* CFG_USE_PARAMETERACCESS */
	call_errorhook(ercd, OSServiceId_GetElapsedValue);
#else /* CFG_USE_ERRORHOOK */
  d_exit_no_errorhook:
	release_cnt_lock(p_ccb);
#endif /* CFG_USE_ERRORHOOK */
	x_nested_unlock_os_int();
	goto exit_no_errorhook;
}

#endif /* TOPPERS_GetElapsedValue */

/*
 *  ϡɥλ
 *
 *  ߥ롼¹Ԥ
 */
#ifdef TOPPERS_notify_hardware_counter

void
notify_hardware_counter(CounterType cntid)
{
	CNTCB	*p_cntcb;
	CCB		*p_ccb;

	p_cntcb = get_cntcb(cntid);
	p_ccb = get_p_ccb(p_cntcb->p_cntinib->coreid);

	/* λOSߤػ */
	x_nested_lock_os_int();

	/*
	 *  ϡɥ󥿤бC2ISRưݤˡ
	 *  ׵Υꥢ¹Ԥ
	 */
	(hwcntinib_table[cntid].intclear)();

	acquire_cnt_lock(p_ccb);
	expire_process(p_cntcb, cntid);
	release_cnt_lock(p_ccb);

	x_nested_unlock_os_int();
}

#endif /* TOPPERS_notify_hardware_counter */

/*
 *  󥿤Υ󥯥
 *
 *  ߶ػ߾֤ǸƤФ
 */
#ifdef TOPPERS_incr_counter_process

StatusType
incr_counter_process(CNTCB *p_cntcb, CounterType CounterID)
{
	StatusType	ercd = E_OK;
	TickType	newval;
	CCB			*p_ccb;

	LOG_INCCNT_ENTER(CounterID);
	p_ccb = get_p_ccb(p_cntcb->p_cntinib->coreid);

	acquire_cnt_lock(p_ccb);

	/*
	 *  󥿤(IncrementCounterΥͥȡˤξ票顼
	 *  ȼ
	 */
	D_CHECK_STATE(p_cntcb->cstat == CS_NULL);

	p_cntcb->cstat = CS_DOING;

	newval = add_tick(p_cntcb->curval, 1U, p_cntcb->p_cntinib->maxval2);

	p_cntcb->curval = newval;

	if (p_ccb->p_runisr == NULL) {
		p_cntcb->p_prevcntcb = p_ccb->p_runtsk->p_lastcntcb;
		p_ccb->p_runtsk->p_lastcntcb = p_cntcb;
	}

	expire_process(p_cntcb, CounterID);

	if (p_ccb->p_runisr == NULL) {
		p_ccb->p_runtsk->p_lastcntcb = p_cntcb->p_prevcntcb;
	}

	p_cntcb->cstat = CS_NULL;

  d_exit_no_errorhook:
	release_cnt_lock(p_ccb);
	LOG_INCCNT_LEAVE(ercd);
	return(ercd);

#ifdef CFG_USE_ERRORHOOK
  d_exit_errorhook:
	release_cnt_lock(p_ccb);
#ifdef CFG_USE_PARAMETERACCESS
	get_my_p_ccb()->_errorhook_par1.cntid = CounterID;
#endif /* CFG_USE_PARAMETERACCESS */
	call_errorhook(ercd, OSServiceId_IncrementCounter);
	goto d_exit_no_errorhook;
#endif /* CFG_USE_ERRORHOOK */
}

#endif /* TOPPERS_incr_counter_process */

/*
 *  顼λˤ륫󥿤Υ󥯥
 *
 *  ߶ػ߾֤ǸƤФ
 */
#ifdef TOPPERS_incr_counter_action

StatusType
incr_counter_action(OSAPCB *p_expire_osapcb, CounterType CounterID)
{
	StatusType	ercd = E_OK;
	CNTCB		*p_cntcb;
	CCB			*p_ccb;
	OSAPCB		*p_osapcb;

	p_cntcb = get_cntcb(CounterID);
	p_osapcb = p_cntcb->p_cntinib->p_osapcb;
	p_ccb = get_p_ccb(p_cntcb->p_cntinib->coreid);

	/* λ°OSAPڤӥ󥯥ȥ󥿽°OSAPξ֤å */
	D_CHECK_ACCESS((p_osapcb->osap_stat == APPLICATION_ACCESSIBLE) || (p_osapcb == p_expire_osapcb));

	ercd = incr_counter_process(p_cntcb, CounterID);

  d_exit_no_errorhook:
	return(ercd);

#ifdef CFG_USE_ERRORHOOK
  d_exit_errorhook:
#ifdef CFG_USE_PARAMETERACCESS
	get_my_p_ccb()->_errorhook_par1.cntid = CounterID;
#endif /* CFG_USE_PARAMETERACCESS */
	call_errorhook(ercd, OSServiceId_IncrementCounter);
	goto d_exit_no_errorhook;
#endif /* CFG_USE_ERRORHOOK */
}

#endif /* TOPPERS_incr_counter_action */
