/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2008-2015 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2012-2015 by FUJI SOFT INCORPORATED, JAPAN
 *  Copyright (C) 2012-2013 by Spansion LLC, USA
 *  Copyright (C) 2012-2015 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2012-2015 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2012-2014 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2012-2015 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2012-2015 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2012-2015 by Witz Corporation
 *  Copyright (C) 2014-2015 by AISIN COMCRUISE Co., Ltd., JAPAN
 *  Copyright (C) 2014-2015 by eSOL Co.,Ltd., JAPAN
 *  Copyright (C) 2014-2015 by SCSK Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: mc.h 1801 2015-03-27 06:34:43Z t_ishikawa $
 */

/*
 *		ޥ⥸塼
 *		깽¤Ѥޥ
 */

#ifndef TOPPERS_MC_H
#define TOPPERS_MC_H

#ifndef TOPPERS_MACRO_ONLY
/*
 *  ¾ CCB ؤΥ
 */
#define get_p_ccb(id)	(p_ccb_table[id])

/*
 *  ưƤOSΥ
 */
extern uint32 activated_cores;

/*
 *  ưν
 */
extern void ccb_initialize(void);


/*
 *  ֳߥϥɥ鶦̽
 */
extern void ici_handler_main(void);

#ifndef OMIT_KER_REQ_ON_ICI
/*
 *  λ׵ե饰
 */
extern volatile boolean	shutdown_reqflg;

#endif /* OMIT_KER_REQ_ON_ICI */

/*
 *  λ׵
 */
extern void shutdown_request(void);

/*
 *  ХꥢƱ
 */
extern void barrier_sync(uint8 phase, boolean check_shutdown);

/*
 *		⥸塼Ϣ
 */

/*
 *  ǥѥå׵
 */
extern boolean dispatch_request(CCB *p_ccb);


/*
 *		åطǽ
 */

#if TTYPE_KLOCK == G_KLOCK

/*
 *  㥤ȥåξ
 */

/*
 *  㥤ȥåѿ
 */
extern LockType	giant_lock;

/*
 *  ֥ȥȥ֥ååѿμФ
 */
#define GET_SPNLOCK()			(&giant_lock)
#define GET_IOCLOCK()			(&giant_lock)

/*
 *  ǤեʼޤˤΥåμǤդΥƥ/1ܡ
 */
LOCAL_INLINE void
acquire_tsk_lock(CCB *p_ccb)
{
	x_acquire_lock(&giant_lock);
}

/*
 *  åβǤդΥƥȡ
 */
LOCAL_INLINE void
release_tsk_lock(CCB *p_ccb)
{
	x_release_lock(&giant_lock);
}

/*
 *  åβȥǥѥå
 */
LOCAL_INLINE void
release_tsk_lock_and_dispatch(CCB *p_ccb, boolean dspreq)
{
	x_release_lock(&giant_lock);
	if (dspreq != FALSE) {
		dispatch();
	}
}

/*
 *  󥿥åμǤդΥƥȡ
 */
LOCAL_INLINE void
acquire_cnt_lock(CCB *p_ccb)
{
	x_acquire_lock(&giant_lock);
}

/*
 *	󥿥åβǤդΥƥȡ
 */
LOCAL_INLINE void
release_cnt_lock(CCB *p_ccb)
{
	x_release_lock(&giant_lock);
}

/*
 *	ԥåμǤդΥƥȡ
 */
LOCAL_INLINE void
acquire_spn_lock(LockType *p_spnlock)
{
	x_acquire_lock(&giant_lock);
}

/*
 *	ԥåβǤդΥƥȡ
 */
LOCAL_INLINE void
release_spn_lock(LockType *p_spnlock)
{
	x_release_lock(&giant_lock);
}

/*
 *	ԥåμԡǤդΥƥȡ
 */
LOCAL_INLINE boolean
try_spn_lock(LockType *p_spnlock)
{
	return(x_try_lock(&giant_lock));
}

/*
 *  IOCåμǤդΥƥȡ
 */
LOCAL_INLINE void
acquire_ioc_lock(LockType *p_ioclock)
{
	x_acquire_lock(&giant_lock);
}

/*
 *	IOCåβǤդΥƥȡ
 */
LOCAL_INLINE void
release_ioc_lock(LockType *p_ioclock)
{
	x_release_lock(&giant_lock);
}

#else /* TTYPE_KLOCK != G_KLOCK */
/*
 *  åξ
 */

/*
 *  åѿ
 */
extern LockType	spn_lock;
extern LockType	ioc_lock;

/*
 *  ֥ȥȥ֥ååѿμФ
 */
#define GET_SPNLOCK()			(&spn_lock)
#define GET_IOCLOCK()			(&ioc_lock)

/*
 *  ǤեʼޤˤΥåμǤդΥƥ/1ܡ
 */
extern void acquire_tsk_lock(CCB *p_ccb);

/*
 *  󥿥åμǤդΥƥȡ
 */
extern void acquire_cnt_lock(CCB *p_ccb);

/*
 *  åβǤդΥƥȡ
 */
extern void release_tsk_lock(CCB *p_ccb);

/*
 *  åβȥǥѥå
 */
extern void release_tsk_lock_and_dispatch(CCB *p_ccb,  boolean dspreq);

/*
 * 󥿥åβǤդΥƥȡ
 */
extern void release_cnt_lock(CCB *p_ccb);

/*
 *	ԥåμǤդΥƥȡ
 */
extern void acquire_spn_lock(LockType *p_spnlock);

/*
 *	ԥåβǤդΥƥȡ
 */
extern void release_spn_lock(LockType *p_spnlock);

/*
 *	ԥåμԡǤդΥƥȡ
 */
extern boolean try_spn_lock(LockType *p_spnlock);

/*
 *  IOCåμǤդΥƥȡ
 */
extern void acquire_ioc_lock(LockType *p_ioclock);

/*
 *	IOCåβǤդΥƥȡ
 */
extern void release_ioc_lock(LockType *p_ioclock);

#endif /* TTYPE_KLOCK != G_KLOCK */

#endif /* TOPPERS_MACRO_ONLY */

#endif /* TOPPERS_MC_H */
