/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2015 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011-2015 by FUJI SOFT INCORPORATED, JAPAN
 *  Copyright (C) 2011-2013 by Spansion LLC, USA
 *  Copyright (C) 2011-2015 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2011-2015 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2011-2014 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2011-2015 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2011-2015 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2011-2015 by Witz Corporation
 *  Copyright (C) 2014-2015 by AISIN COMCRUISE Co., Ltd., JAPAN
 *  Copyright (C) 2014-2015 by eSOL Co.,Ltd., JAPAN
 *  Copyright (C) 2014-2015 by SCSK Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: memory.c 1801 2015-03-27 06:34:43Z t_ishikawa $
 */

#include "kernel_impl.h"
#include "check.h"
#include "task.h"
#include "interrupt.h"
#include "memory.h"

/*
 *		ꥪ֥ȴ⥸塼
 */

/*
 *  ȥ졼ޥΥǥե
 */

#ifndef LOG_CHKISRMEMACS_ENTER
#define LOG_CHKISRMEMACS_ENTER(ISRID, Address, Size)
#endif /* LOG_CHKISRMEMACS_ENTER */

#ifndef LOG_CHKISRMEMACS_LEAVE
#define LOG_CHKISRMEMACS_LEAVE(ercd)
#endif /* LOG_CHKISRMEMACS_LEAVE */

#ifndef LOG_CHKTSKMEMACS_ENTER
#define LOG_CHKTSKMEMACS_ENTER(TaskID, Address, Size)
#endif /* LOG_CHKTSKMEMACS_ENTER */

#ifndef LOG_CHKTSKMEMACS_LEAVE
#define LOG_CHKTSKMEMACS_LEAVE(ercd)
#endif /* LOG_CHKTSKMEMACS_LEAVE */


/*
 *  ؿΥץȥ
 */
#ifndef USE_TSKINICTXB

LOCAL_INLINE AccessType check_address_sstack(const MemoryStartAddressType base, MemorySizeType size, const TINIB *p_tinib);
LOCAL_INLINE AccessType check_address_ustack(const MemoryStartAddressType base, MemorySizeType size, const TINIB *p_tinib);

#endif /* USE_TSKINICTXB */

/*
 *  ꥢåƥॵӥ
 *  ꤵ줿   ꤵ줿ΰΥå
 */
#ifdef TOPPERS_CheckTaskMemoryAccess

AccessType
CheckTaskMemoryAccess(TaskType TaskID, MemoryStartAddressType Address, MemorySizeType Size)
{
	AccessType	access;
	StatusType	ercd;
	TCB			*p_tcb;
	boolean		over_region;

	LOG_CHKTSKMEMACS_ENTER(TaskID, Address, Size);

	CHECK_DISABLEDINT();
	CHECK_CALLEVEL(CALLEVEL_CHECKTASKMEMORYACCESS);
	CHECK_ID(TaskID < tnum_task);
	CHECK_VALUE(Size > 0U);

	p_tcb = get_tcb(TaskID);
	CHECK_CORE(p_tcb->p_tinib != NULL);

	access = check_task_memory(p_tcb, Address, Size, &over_region);
	CHECK_ILLEGAL_ADDRESS(over_region == FALSE);

  exit_finish:
	LOG_CHKTSKMEMACS_LEAVE(access);
	return(access);

#ifdef CFG_USE_ERRORHOOK
  exit_errorhook:
	x_nested_lock_os_int();
#ifdef CFG_USE_PARAMETERACCESS
	get_my_p_ccb()->_errorhook_par1.tskid = TaskID;
	get_my_p_ccb()->_errorhook_par2.adr = Address;
	get_my_p_ccb()->_errorhook_par3.sz = Size;
#endif /* CFG_USE_PARAMETERACCESS */
	call_errorhook(ercd, OSServiceId_CheckTaskMemoryAccess);
	x_nested_unlock_os_int();
#endif /* CFG_USE_ERRORHOOK */

  exit_no_errorhook:
	access = AP_NoAccess;
	goto exit_finish;
}

#endif /* TOPPERS_CheckTaskMemoryAccess */

/*
 *  ISRꥢåƥॵӥ
 *  ꤵ줿 ISR  ꤵ줿ΰΥå
 */
#ifdef TOPPERS_CheckISRMemoryAccess

AccessType
CheckISRMemoryAccess(ISRType ISRID, MemoryStartAddressType Address, MemorySizeType Size)
{
	AccessType	access;
	StatusType	ercd;
	ISRCB		*p_isrcb;
	boolean		over_region;

	LOG_CHKISRMEMACS_ENTER(ISRID, Address, Size);

	CHECK_DISABLEDINT();
	CHECK_CALLEVEL(CALLEVEL_CHECKISRMEMORYACCESS);
	CHECK_ID(ISRID < tnum_isr2);
	CHECK_VALUE(Size > 0U);

	p_isrcb = get_isrcb(ISRID);
	CHECK_CORE(p_isrcb->p_isrinib != NULL);

	access = check_isr_memory(p_isrcb, Address, Size, &over_region);
	CHECK_ILLEGAL_ADDRESS(over_region == FALSE);

  exit_finish:
	LOG_CHKISRMEMACS_LEAVE(access);
	return(access);

#ifdef CFG_USE_ERRORHOOK
  exit_errorhook:
	x_nested_lock_os_int();
#ifdef CFG_USE_PARAMETERACCESS
	get_my_p_ccb()->_errorhook_par1.isrid = ISRID;
	get_my_p_ccb()->_errorhook_par2.adr = Address;
	get_my_p_ccb()->_errorhook_par3.sz = Size;
#endif /* CFG_USE_PARAMETERACCESS */
	call_errorhook(ercd, OSServiceId_CheckISRMemoryAccess);
	x_nested_unlock_os_int();
#endif /* CFG_USE_ERRORHOOK */

  exit_no_errorhook:
	access = AP_NoAccess;
	goto exit_finish;
}

#endif /* TOPPERS_CheckISRMemoryAccess */

/*
 *  ꥢåؿ
 */

/*
 *  åå
 */
#ifdef TOPPERS_check_address_stack

AccessType
check_address_stack(const MemoryStartAddressType base, MemorySizeType size, const MemoryStartAddressType mobase, MemorySizeType mosize)
{
	AccessType result;
	if (within_memobj(base, size, mobase, mosize) != FALSE) {
		result = AP_Readable | AP_Writable | AP_StackSpace;
	}
	else {
		result = NO_ACCESS;
	}
	return(result);
}

#endif /* TOPPERS_check_address_stack */

#ifndef USE_TSKINICTXB

LOCAL_INLINE AccessType
check_address_sstack(const MemoryStartAddressType base, MemorySizeType size, const TINIB *p_tinib)
{
	return(check_address_stack(base, size, p_tinib->sstk, p_tinib->sstksz));
}

LOCAL_INLINE AccessType
check_address_ustack(const MemoryStartAddressType base, MemorySizeType size, const TINIB *p_tinib)
{
	return(check_address_stack(base, size, p_tinib->ustk, p_tinib->ustksz));
}

#endif /* USE_TSKINICTXB */


#ifndef OMIT_STANDARD_MEMINIB
/*
 *  ꥪ֥Ƚ֥åθ
 */
#ifdef TOPPERS_search_meminib

uint32
search_meminib(MemoryStartAddressType addr)
{
	uint32 left, right, i;

	left = 0U;
	right = tnum_meminib - 1U;
	while (left < right) {
		i = (left + right + 1U) / 2U;
		if (addr < (MemoryStartAddressType const) memtop_table[i]) {
			right = i - 1U;
		}
		else {
			left = i;
		}
	}
	return(left);
}

#endif /* TOPPERS_search_meminib */
/*
 *  ꥢå
 *   ץƥñ(OSץꥱ) ǤΥåԤ
 *
 *  OSץꥱξϡХå饦ɤå
 *    Ǥΰ襢ǽ
 *  OSץꥱξϡꥪ֥Ȥ°ֵѤ
 */
#ifdef TOPPERS_check_osap_memory

AccessType
check_osap_memory(OSAPCB *p_osapcb, const MemoryStartAddressType adr, MemorySizeType size)
{
	AccessType				access = AP_NoAccess;
	const MEMINIB			*p_meminib;
	uint32					pos;
	uint32					btptn;
	MemoryStartAddressType	sadr = adr;
	MemoryStartAddressType	eadr = (MemoryStartAddressType) ((MemorySizeType) sadr + size);

	if (p_osapcb->p_osapinib->osap_trusted != FALSE) {
		access = probe_trusted_osap_mem(sadr, eadr);
	}
	else {

		pos = search_meminib(sadr);
		p_meminib = &(meminib_table[pos]);
		if ((pos + 1U) < tnum_meminib) {
			if (((uint8 *) eadr - 1) < (uint8 * const) memtop_table[pos + 1U]) {
				btptn = p_osapcb->p_osapinib->btptn;
				access |= ((p_meminib->acptnr & btptn) != 0U) ? AP_Readable   : AP_NoAccess;
				access |= ((p_meminib->acptnw & btptn) != 0U) ? AP_Writable   : AP_NoAccess;
				access |= ((p_meminib->acptnx & btptn) != 0U) ? AP_Executable : AP_NoAccess;
			}
		}
	}
	return(access);
}

#endif /* TOPPERS_check_osap_memory */

/*
 *  ISRꥢåƥॵӥ(ͥ)
 */
#ifdef TOPPERS_check_isr_memory

AccessType
check_isr_memory(ISRCB *p_isrcb, const MemoryStartAddressType adr, MemorySizeType size, boolean *over_region)
{
	AccessType				access = AP_NoAccess;
	uint32					pos;
	MemoryStartAddressType	sadr = adr;
	MemorySizeType			memsize;
	CCB						*p_ccb = get_my_p_ccb();

	pos = search_meminib(sadr);
	memsize = (MemorySizeType) (((uint8 *) (((pos + 1U) < tnum_meminib) ?
											((uint8 * const) memtop_table[pos + 1U]) : 0U)) - (const uint8 *) adr);

	/* ꡼٤äȽ */
	if (size > memsize) {
		*over_region = TRUE;
	}
	else {
		*over_region = FALSE;
		access = check_address_stack(adr, size, _ostk_table[p_ccb->coreid], _ostksz_table[p_ccb->coreid]);
	}

	/* ǽ٥2ǤC2ISRϿꤷʤΤǡǽˤ */
	access |= (AP_Readable | AP_Writable | AP_Executable);

	return(access);
}

#endif /* TOPPERS_check_isr_memory */

/*
 *  ꥢåƥॵӥ(ͥ)
 */
#ifdef TOPPERS_check_task_memory

AccessType
check_task_memory(const TCB *p_tcb, const MemoryStartAddressType adr, MemorySizeType size, boolean *over_region)
{
	AccessType				access = AP_NoAccess;
	const MEMINIB			*p_meminib;
	uint32					pos;
	uint32					btptn;
	MemoryStartAddressType	sadr = adr;
	MemorySizeType			memsize;

	pos = search_meminib(sadr);
	memsize = (MemorySizeType) (((uint8 *) (((pos + 1U) < tnum_meminib) ?
											((uint8 * const) memtop_table[pos + 1U]) : 0U)) - (const uint8 *) adr);

	/* ꡼٤äȽ */
	if (size > memsize) {
		*over_region = TRUE;
	}
	else {
		*over_region = FALSE;
	}

	if (p_tcb->p_tinib->p_osapcb->p_osapinib->osap_trusted != FALSE) {
		access = check_address_sstack(adr, size, p_tcb->p_tinib);

		/* ꥿ξǽ */
		access |= (AP_Readable | AP_Writable | AP_Executable);
	}
	else if (*over_region == FALSE) {
		p_meminib = &(meminib_table[pos]);
		if ((p_meminib->mematr & TOPPERS_USTACK) == 0U) {
			btptn = p_tcb->p_tinib->p_osapcb->p_osapinib->btptn;
			access |= ((p_meminib->acptnr & btptn) != 0U) ? AP_Readable   : AP_NoAccess;
			access |= ((p_meminib->acptnw & btptn) != 0U) ? AP_Writable   : AP_NoAccess;
			access |= ((p_meminib->acptnx & btptn) != 0U) ? AP_Executable : AP_NoAccess;
		}
		else {
			access = check_address_ustack(adr, size, p_tcb->p_tinib);
		}
	}
	else {
		/* 嵭ʳξ硤ϹԤʤ(͡AP_NoAccess) */
	}

	return(access);
}

#endif /* TOPPERS_check_task_memory */
#endif /* OMIT_STANDARD_MEMINIB */

/*
 *  ȥåץեååȥեå
 *  ꥢåƥॵӥ(ͥ)
 */
#ifdef TOPPERS_check_hook_memory

AccessType
check_hook_memory(const MemoryStartAddressType adr, MemorySizeType size)
{
	AccessType				access;
	MemoryStartAddressType	eadr = (MemoryStartAddressType) ((const MemorySizeType) adr + size);
	CCB						*p_ccb = get_my_p_ccb();

	access = probe_nthkstk(adr, eadr);

	if (access == AP_NoAccess) {
		access = check_osap_memory(p_ccb->p_runosap, adr, size);
	}

	return(access);
}

#endif /* TOPPERS_check_hook_memory */

/*
 *  ꥢΥå
 */
#ifdef TOPPERS_probe_memory_access

AccessType
probe_memory_access(const MemoryStartAddressType base, MemorySizeType size)
{
	AccessType				access;
	boolean					dummy;
	MemoryStartAddressType	base_adr = base;
	CCB						*p_ccb = get_my_p_ccb();

	if (p_ccb->run_trusted != FALSE) {
		/* OSץꥱξϡХå饦ɤå */
		access = probe_trusted_osap_mem(base, (MemoryStartAddressType) ((uint8 *) base_adr + size));
	}
	else {
		/*
		 *  OSץꥱξϡ¹Υեå롼󡤥
		 *  å
		 */
		if (is_running_nontrusted_hook() != FALSE) {
			access = check_hook_memory(base, size);
		}
		else {
			access = check_task_memory(p_ccb->p_runtsk, base, size, &dummy);
		}
	}
	return(access);
}

#endif /* TOPPERS_probe_memory_access */

/*
 *  ؤν߸Υå
 */
#ifdef TOPPERS_probe_memory_read

boolean
probe_memory_read(const MemoryStartAddressType base, MemorySizeType size)
{
	return((probe_memory_access(base, size) & AP_Readable) == AP_Readable);
}

#endif /* TOPPERS_probe_memory_read */

/*
 *  ؤν߸Υå
 */
#ifdef TOPPERS_probe_memory_write

boolean
probe_memory_write(const MemoryStartAddressType base, MemorySizeType size)
{
	return((probe_memory_access(base, size) & AP_Writable) == AP_Writable);
}

#endif /* TOPPERS_probe_memory_write */

/*
 *  Фɽ񤭸Υå
 */
#ifdef TOPPERS_probe_memory_read_write

boolean
probe_memory_read_write(const MemoryStartAddressType base, MemorySizeType size)
{
	return((probe_memory_access(base, size) & (AP_Readable | AP_Writable)) == (AP_Readable | AP_Writable));
}

#endif /* TOPPERS_probe_memory_read_write */

/*
 *  DATABSSν
 */
#ifdef TOPPERS_initialize_sections
#ifndef OMIT_INITIALIZE_SECTIONS

void
initialize_sections(void)
{
	uint32				i;
	uint8				*p_src, *p_dst;
	const DATASECINIB	*p_datasecinib;
	const BSSSECINIB	*p_bsssecinib;

	for (i = 0U; i < tnum_datasec; i++) {
		p_datasecinib = &(datasecinib_table[i]);
		p_src = (uint8 *) p_datasecinib->start_idata;
		for (p_dst = (uint8 *) p_datasecinib->start_data;
			 ((const MemoryStartAddressType) p_dst) < (const MemoryStartAddressType) p_datasecinib->end_data; p_dst++) {
			*p_dst = *p_src;
			p_src++;
		}
	}
	for (i = 0U; i < tnum_bsssec; i++) {
		p_bsssecinib = &(bsssecinib_table[i]);
		for (p_dst = (uint8 *) p_bsssecinib->start_bss;
			 ((const MemoryStartAddressType) p_dst) < (const MemoryStartAddressType) p_bsssecinib->end_bss; p_dst++) {
			*p_dst = 0U;
		}
	}
}

#endif /* OMIT_INITIALIZE_SECTIONS */
#endif /* TOPPERS_initialize_sections */
