/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2015 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011-2015 by FUJI SOFT INCORPORATED, JAPAN
 *  Copyright (C) 2011-2013 by Spansion LLC, USA
 *  Copyright (C) 2011-2015 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2011-2015 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2011-2014 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2011-2015 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2011-2015 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2011-2015 by Witz Corporation
 *  Copyright (C) 2014-2015 by AISIN COMCRUISE Co., Ltd., JAPAN
 *  Copyright (C) 2014-2015 by eSOL Co.,Ltd., JAPAN
 *  Copyright (C) 2014-2015 by SCSK Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: memory.h 1801 2015-03-27 06:34:43Z t_ishikawa $
 */

/*
 *		ꥢϢǽ
 */

#ifndef TOPPERS_MEMORY_H
#define TOPPERS_MEMORY_H

#include "interrupt.h"
#include "task.h"

/*
 *  °ʥͥѤ
 */
#define TOPPERS_ATTSEC	UINT_C(0x0100)  /* ATT_SEC/ATT_MODϿ줿ꥪ֥ */
#define TOPPERS_ATTMEM	UINT_C(0x0200)  /* ATT_MEMϿ줿ꥪ֥ */
#define TOPPERS_USTACK	UINT_C(0x0400)  /* /C2ISRΥ桼åΰ */

#ifndef TOPPERS_MACRO_ONLY

typedef	uint32 AccessPatternType;      /* ĥѥ */

/*
 *  ĥѥ
 */
#define TACP_KERNEL		(0U)            /* ͥɥᥤ˥ */
#define TACP_SHARED		(~0U)           /* ٤ƤΥɥᥤ󤫤饢 */

#ifndef OMIT_STANDARD_MEMINIB

/*
 *  ꥪ֥Ƚ֥å
 */
typedef struct memory_initialization_block {
	AttributeType		mematr;         /* ꥪ֥° */
	AccessPatternType	acptnr;         /* ꡼ɵ OSץꥱ ӥåȥѥ */
	AccessPatternType	acptnw;         /* 饤ȵ OSץꥱ ӥåȥѥ */
	AccessPatternType	acptnx;         /* ¹Ե   OSץꥱ ӥåȥѥ */
} MEMINIB;

/*
 *  ꥪ֥Ƚ֥åοkernel_mem.c
 */
extern const uint32		tnum_meminib;

/*
 *  ꥪ֥ȤƬϤΰkernel_mem.c
 */
extern void * const	memtop_table[];

/*
 *  ꥪ֥Ƚ֥åΰkernel_mem.c
 */
extern const MEMINIB	meminib_table[];

/*
 *  ꥪ֥Ƚ֥åθ
 *
 *  ꥪ֥Ƚ֥å顤addrޤꥪ֥
 *  򸡺Υǥå֤
 */

extern uint32 search_meminib(MemoryStartAddressType addr);

#endif /* OMIT_STANDARD_MEMINIB */

/*
 *  ΰ褬ꥪ֥Ȥ˴ޤޤƤ뤫Υå
 *
 *  ƬϤbaseǥsizeΥΰ褬ƬϤmobaseǥ
 *  mosizeΥꥪ֥Ȥ˴ޤޤƤTRUEǤʤ
 *  FALSE֤
 */

LOCAL_INLINE boolean
within_memobj(MemoryStartAddressType base, MemorySizeType size, MemoryStartAddressType mobase, MemorySizeType mosize)
{
	return((mobase <= base) && (size <= mosize)
		   && (((MemorySizeType) base - (MemorySizeType) mobase) <= (mosize - size)));
}

/*
 *  åå
 */
extern AccessType check_address_stack(const MemoryStartAddressType base, MemorySizeType size, const MemoryStartAddressType mobase, MemorySizeType mosize);

/*
 *  ꥢå
 */
extern AccessType check_osap_memory(OSAPCB *p_osapcb, const MemoryStartAddressType adr, MemorySizeType size);

/*
 *  ISRꥢåƥॵӥ(ͥ)
 */
extern AccessType check_isr_memory(ISRCB *p_isrcb, const MemoryStartAddressType adr, MemorySizeType size, boolean *over_region);

/*
 *  ꥢåƥॵӥ(ͥ)
 */
extern AccessType check_task_memory(const TCB *p_tcb, const MemoryStartAddressType adr, MemorySizeType size, boolean *over_region);

/*
 *  ȥåץեååȥեå
 *  ꥢåƥॵӥ(ͥ)
 */
extern AccessType check_hook_memory(const MemoryStartAddressType adr, MemorySizeType size);

/*
 *  ꥢΥå
 */
extern AccessType probe_memory_access(const MemoryStartAddressType base, MemorySizeType size);

/*
 *  ؤɹ߸Υå
 */
extern boolean probe_memory_read(const MemoryStartAddressType base, MemorySizeType size);

/*
 *  ؤν߸Υå
 */
extern boolean probe_memory_write(const MemoryStartAddressType base, MemorySizeType size);

/*
 *  Фɽ񤭸Υå
 */
extern boolean probe_memory_read_write(const MemoryStartAddressType base, MemorySizeType size);

/*
 *  DATABSSν
 */
extern void initialize_sections(void);

/*
 *  ꥢåΤΥޥ
 */
#ifndef PROBE_MEM_WRITE
#define PROBE_MEM_WRITE(p_var, type) \
	(boolean) ((probe_memory_write((MemoryStartAddressType) (p_var), sizeof(type)) != FALSE) && (ALIGNED_TYPE(p_var, type) != FALSE))
#endif /* PROBE_MEM_WRITE */

#ifndef PROBE_MEM_RW
#define PROBE_MEM_RW(p_var, type) \
	(boolean) ((probe_memory_read_write((MemoryStartAddressType) (p_var), sizeof(type)) != FALSE) && (ALIGNED_TYPE(p_var, type) != FALSE))
#endif /* PROBE_MEM_RW */

/*
 *  data֥å
 */
typedef struct {
	void	*start_data;        /* dataƬ */
	void	*end_data;          /* dataνλ */
	void	*start_idata;       /* ǡΰƬ */
} DATASECINIB;

/*
 *  dataοȽ֥åΥꥢkernel_mem_2.c
 */
extern const uint32			tnum_datasec;
extern const DATASECINIB	datasecinib_table[];

/*
 *  bss֥å
 */
typedef struct {
	void	*start_bss;         /* bssƬ */
	void	*end_bss;           /* bssνλ */
} BSSSECINIB;

/*
 *  bssοȽ֥åΥꥢkernel_mem_2.c
 */
extern const uint32		tnum_bsssec;
extern const BSSSECINIB	bsssecinib_table[];

#endif /* TOPPERS_MACRO_ONLY */
#endif /* TOPPERS_MEMORY_H_ */
