/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2004-2015 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011-2015 by FUJI SOFT INCORPORATED, JAPAN
 *  Copyright (C) 2011-2013 by Spansion LLC, USA
 *  Copyright (C) 2011-2015 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2011-2015 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2011-2014 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2011-2015 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2011-2015 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2011-2015 by Witz Corporation
 *  Copyright (C) 2014-2015 by AISIN COMCRUISE Co., Ltd., JAPAN
 *  Copyright (C) 2014-2015 by eSOL Co.,Ltd., JAPAN
 *  Copyright (C) 2014-2015 by SCSK Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: osap.h 1801 2015-03-27 06:34:43Z t_ishikawa $
 */

/*
 *		OSץꥱǽ
 */

#ifndef TOPPERS_OSAP_H
#define TOPPERS_OSAP_H

/*
 *  OSץꥱ°
 */
#define TA_NONTRUSTED			(FALSE)
#define TA_TRUSTED				(TRUE)

/*
 *  OSץꥱIDOSAPINIBФΥޥ
 */
#define get_osapinib(osapid)	(&(osapinib_table[(osapid)]))

/*
 *  OSAPIDOSAPCBФΥޥ
 */
#define get_osapcb(osapid)		(p_osapcb_table[(osapid)])

/*
 *  OSAPCBOSץꥱIDФΥޥ
 */
#define OSAPID(p_osapcb)	((ApplicationType) (((p_osapcb)->p_osapinib) - (osapinib_table)))

#ifndef TOPPERS_MACRO_ONLY

/*
 *  OSץꥱ֥å
 *
 *  OSץꥱ˴ؤOSץꥱ֥å
 *  
 *  ¾Υ֥ȤϡROM֤֥åRAM֤֥å
 *  ǹƤ뤬OSץꥱ˴ؤϼ¹Իѹ
 *  뤳Ȥʤᡤ֥å֥åȤƻѤ
 *
 *  ATK2-SC3ǤϡץƥǽΤξ뤬
 *  ץƥCPU˰¸뤿ᡤץƥ
 *  Τϵ¸˻
 */
typedef struct os_application_initialization_block {
	void (*StartupHook)(void);
	void (*ErrorHook)(StatusType);
	void (*ShutdownHook)(StatusType);
	TCB			*p_restart_tcb;                         /* OSAPΥꥹȥ֥åؤΥݥ */
	boolean		osap_trusted;                           /* OSץꥱ° */
	CoreIdType	coreid;                                 /* OSץꥱγդ */
	uint32		btptn;                                  /* OSץꥱΥӥåȥѥ */

#ifndef OMIT_OSAPMPUINFOB
	OSAPMPUINFOB osap_mpu;                              /* OSץꥱMPU */
#endif

} OSAPINIB;

/*
 *  OSץꥱ֥å
 */
struct os_application_control_block {
	const OSAPINIB			*p_osapinib;                /* ֥åؤΥݥ */
	ApplicationStateType	osap_stat;                  /* OSAP */
};

/*
 *  OSץꥱݻѿOs_Lcfg.c
 */
extern const ApplicationType			tnum_osap;      /* OSץꥱο */

extern const TrustedFunctionIndexType	tnum_tfn;       /* ؿο */

typedef StatusType (*TrustedFunctionRefType)(TrustedFunctionIndexType FunctionIndex,
											 TrustedFunctionParameterRefType FunctionParams);

/*
 *  ؿ֥å
 */
typedef struct trusted_function_initialization_block {
	TrustedFunctionRefType	trs_func;   /* ؿεư */
	MemorySizeType			tf_stksz;   /* å */
	CoreIdType				coreid;     /* դ */
} TFINIB;

/*
 *  OSAPCBΥꥢOs_Lcfg.c
 */
extern OSAPCB * const	p_osapcb_table[];


/*
 *  OSAPINIBγȡkernel_mem.c
 */
extern const OSAPINIB	osapinib_table[];

/*
 *  TFINIBγȡOs_Lcfg.c
 */
extern const TFINIB		tfinib_table[];

/*
 *  OSAPλ/Ƶưؿ(ƥॵӥθƤӽФ)
 */
extern void term_osap_for_sys_svc(OSAPCB *p_osapcb, RestartType RestartOption, boolean other_core_flg);

/*
 *  OSAPλ/Ƶưؿ(ץƥեåΥ꥿)
 */
extern void term_osap_for_protec_hk(OSAPCB *p_osapcb, RestartType RestartOption);

/*
 *  OSAPλ/Ƶưؿ(ֳߤθƤӽФ)
 */
extern void term_osap_for_other_core(void);

/*
 *  OSץꥱ⥸塼ν
 */
extern void osap_initialize(void);

#endif /* TOPPERS_MACRO_ONLY */

#endif /* TOPPERS_OSAP_H_ */
