/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2015 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011-2015 by FUJI SOFT INCORPORATED, JAPAN
 *  Copyright (C) 2011-2013 by Spansion LLC, USA
 *  Copyright (C) 2011-2015 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2011-2015 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2011-2014 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2011-2015 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2011-2015 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2004-2015 by Witz Corporation
 *  Copyright (C) 2014-2015 by AISIN COMCRUISE Co., Ltd., JAPAN
 *  Copyright (C) 2014-2015 by eSOL Co.,Ltd., JAPAN
 *  Copyright (C) 2014-2015 by SCSK Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: task.c 1801 2015-03-27 06:34:43Z t_ishikawa $
 */

/*
 *		⥸塼
 */

#include "kernel_impl.h"
#include "check.h"
#include "task.h"
#include "interrupt.h"

/*
 *  ȥ졼ޥΥǥե
 */
#ifndef LOG_TSKSTAT
#define LOG_TSKSTAT(p_tcb)
#endif /* LOG_TSKSTAT */

/* ؿΥץȥ */
LOCAL_INLINE boolean primap_empty(const CCB *p_ccb);
LOCAL_INLINE PriorityType primap_search(const CCB *p_ccb);
LOCAL_INLINE void primap_set(CCB *p_ccb, PriorityType pri);
LOCAL_INLINE void primap_clear(CCB *p_ccb, PriorityType pri);

#ifdef TOPPERS_task_initialize

/*
 *  ⥸塼ν
 */
void
task_initialize(void)
{
	TaskType	i;
	TCB			*p_tcb;
	CCB			*p_ccb;

	p_ccb = get_my_p_ccb();
	for (i = 0U; i < tnum_task; i++) {
		if (tinib_table[i].p_ccb == p_ccb) {
			p_tcb = p_tcb_table[i];
			p_tcb->p_tinib = &(tinib_table[i]);
			p_tcb->actcnt = 0U;
			p_tcb->curevt = 0U;
			p_tcb->tstat = SUSPENDED;
#ifdef CFG_USE_PROTECTIONHOOK
			p_tcb->calltfn = FALSE;
#endif /* CFG_USE_PROTECTIONHOOK */
			if ((p_tcb->p_tinib->autoact & ((AppModeType) 1 << appmodeid)) != APPMODE_NONE) {
				(void) make_active(p_tcb);
			}
		}
	}
}

#endif /* TOPPERS_task_initialize */

/*
 *  ͥ٥ӥåȥޥåפΥå
 */
LOCAL_INLINE boolean
primap_empty(const CCB *p_ccb)
{
	return(p_ccb->ready_primap == 0U);
}

/*
 *  ͥ٥ӥåȥޥåפΥ
 */
LOCAL_INLINE PriorityType
primap_search(const CCB *p_ccb)
{
	return((PriorityType) bitmap_search(p_ccb->ready_primap));
}

/*
 *  ͥ٥ӥåȥޥåפΥå
 */
LOCAL_INLINE void
primap_set(CCB *p_ccb, PriorityType pri)
{
	p_ccb->ready_primap |= PRIMAP_BIT(pri);
}

/*
 *  ͥ٥ӥåȥޥåפΥꥢ
 */
LOCAL_INLINE void
primap_clear(CCB *p_ccb, PriorityType pri)
{
	p_ccb->ready_primap &= (uint16) ~PRIMAP_BIT(pri);
}

/*
 *  ǹ̥ͥΥ
 */
#ifdef TOPPERS_search_schedtsk

void
search_schedtsk(CCB *p_ccb)
{
	if (primap_empty(p_ccb) != FALSE) {
		p_ccb->p_schedtsk = NULL;
	}
	else {
		p_ccb->p_schedtsk = (TCB *) (queue_delete_next(&(p_ccb->ready_queue[p_ccb->nextpri])));
		if (queue_empty(&(p_ccb->ready_queue[p_ccb->nextpri])) != FALSE) {
			primap_clear(p_ccb, p_ccb->nextpri);
			p_ccb->nextpri = (primap_empty(p_ccb) != FALSE) ?
							 TPRI_MINTASK : primap_search(p_ccb);
		}
	}
}

#endif /* TOPPERS_search_schedtsk */

/*
 *  ¹ԤǤ֤ؤΰܹ
 */
#ifdef TOPPERS_make_runnable

boolean
make_runnable(TCB *p_tcb)
{
	PriorityType	pri, schedpri;
	boolean			is_next_schedtsk = TRUE;
	CCB				*p_ccb;

	p_ccb = p_tcb->p_tinib->p_ccb;
	p_tcb->tstat = READY;
	LOG_TSKSTAT(p_tcb);
	if (p_ccb->p_schedtsk != NULL) {
		pri = p_tcb->curpri;
		schedpri = p_ccb->p_schedtsk->curpri;
		if (pri >= schedpri) {
			/*
			 *  schedtsk ͥ٤⤤硤p_tcb 
			 *  ǥ塼κǸ
			 */
			queue_insert_prev(&(p_ccb->ready_queue[pri]), &(p_tcb->task_queue));
			primap_set(p_ccb, pri);
			if (pri < p_ccb->nextpri) {
				p_ccb->nextpri = pri;
			}
			is_next_schedtsk = FALSE;
		}
		else {
			/*
			 *  p_tcb ͥ٤⤤硤schedtsk ǥ塼
			 *  Ƭ졤p_tcb 򿷤 schedtsk Ȥ
			 */
			queue_insert_next(&(p_ccb->ready_queue[schedpri]), &(p_ccb->p_schedtsk->task_queue));
			primap_set(p_ccb, schedpri);
			p_ccb->nextpri = schedpri;
		}
	}

	if (is_next_schedtsk != FALSE) {
		p_ccb->p_schedtsk = p_tcb;
	}
	return(is_next_schedtsk);
}

#endif /* TOPPERS_make_runnable */

/*
 *  ¹ԤǤ֤¾ξ֤ؤ
 */
#ifdef TOPPERS_make_non_runnable

void
make_non_runnable(CCB *p_ccb)
{
	PriorityType pri;

	if (p_ccb->p_runtsk == p_ccb->p_schedtsk) {
		search_schedtsk(p_ccb);
	}
	else {
		/*
		 *  ¾p_schedtsk줿֤ξϡʬȤ
		 *  ǥ塼ᤵƤ뤿ᡤǥ塼
		 */
		pri = p_ccb->p_runtsk->curpri;
		queue_delete(&(p_ccb->p_runtsk->task_queue));
		if (queue_empty(&(p_ccb->ready_queue[pri])) != FALSE) {
			primap_clear(p_ccb, pri);
			p_ccb->nextpri = (primap_empty(p_ccb) != FALSE) ?
							 TPRI_MINTASK : primap_search(p_ccb);
		}
	}
}

#endif /* TOPPERS_make_non_runnable */

/*
 *  εư
 *
 *  TerminateTask  ChainTask ǡФ make_active 
 *  Ƥ־礬Τդ
 */
#ifdef TOPPERS_make_active

boolean
make_active(TCB *p_tcb)
{
	p_tcb->curpri = p_tcb->p_tinib->inipri;
	if (TSKID(p_tcb) < tnum_exttask) {
		p_tcb->curevt = EVTMASK_NONE;
		p_tcb->waievt = EVTMASK_NONE;
	}
	p_tcb->p_lastrescb = NULL;
	p_tcb->p_lastcntcb = NULL;
	p_tcb->p_lastspncb = NULL;
	activate_context(p_tcb);
	return(make_runnable(p_tcb) != FALSE);
}

#endif /* TOPPERS_make_active */

/*
 *  Υץꥨץ
 */
#ifdef TOPPERS_preempt

void
preempt(CCB *p_ccb, PriorityType pre_pri)
{
	PriorityType pri;

	pri = p_ccb->p_runtsk->curpri;
	if (p_ccb->p_runtsk == p_ccb->p_schedtsk) {
		queue_insert_next(&(p_ccb->ready_queue[pri]), &(p_ccb->p_runtsk->task_queue));
		primap_set(p_ccb, pri);
		search_schedtsk(p_ccb);
	}
	else {
		/*
		 *  ¾p_schedtsk줿֤ξϡʬȤ
		 *  ǥ塼ᤵƤ롥ͥ٤Ѥä硤
		 *  塼ľ
		 */
		/* ꥽ͥ٤ǥǥ塼Ƥ뤿 */
		queue_delete(&(p_ccb->p_runtsk->task_queue));
		if (queue_empty(&(p_ccb->ready_queue[pre_pri])) != FALSE) {
			primap_clear(p_ccb, pre_pri);
			p_ccb->nextpri = (primap_empty(p_ccb) != FALSE) ?
							 TPRI_MINTASK : primap_search(p_ccb);
		}
		/* ꥽ͥ٤ǥǥ塼ɲ */
		queue_insert_next(&(p_ccb->ready_queue[pri]), &(p_ccb->p_runtsk->task_queue));
		primap_set(p_ccb, pri);
	}
}

#endif /* TOPPERS_preempt */

/*
 *  ¹ΥSUSPENDED֤ˤ
 *  ꥽֤ǸƽФɬפ
 */
#ifdef TOPPERS_suspend

void
suspend(CCB *p_ccb)
{
	p_ccb->p_runtsk->tstat = SUSPENDED;
	LOG_TSKSTAT(p_ccb->p_runtsk);
	make_non_runnable(p_ccb);
	if (p_ccb->p_runtsk->actcnt > 0U) {
		p_ccb->p_runtsk->actcnt -= 1U;
		(void) make_active(p_ccb->p_runtsk);
	}
}

#endif /* TOPPERS_suspend */

/*
 *  ꥽ֵ
 */
#ifdef TOPPERS_release_taskresources

void
release_taskresources(TCB *p_tcb)
{
	if (p_tcb->p_lastrescb != NULL) {
		if (p_tcb->curpri <= TPRI_MINISR) {
			/* ꥽гߵĤˤʤ */
			x_set_ipm((PriorityType) TIPM_ENAALL);
		}
		/* ꥽м¹ͥ٤ */
		p_tcb->curpri = p_tcb->p_tinib->exepri;

		/* OS߶ػ߾ְʾ */
		do {
			p_tcb->p_lastrescb->lockflg = FALSE;
			p_tcb->p_lastrescb = p_tcb->p_lastrescb->p_prevrescb;
		} while (p_tcb->p_lastrescb != NULL);
	}
}

#endif /* TOPPERS_release_taskresources */

/*
 *  Υ󥿤ξ֤򤹤٤CS_NULL᤹
 */
#ifdef TOPPERS_cancel_taskcounters

void
cancel_taskcounters(TCB *p_tcb)
{
	if (p_tcb->p_lastcntcb != NULL) {

		/* OS߶ػ߾ְʾ */
		do {
			p_tcb->p_lastcntcb->cstat = CS_NULL;
			p_tcb->p_lastcntcb = p_tcb->p_lastcntcb->p_prevcntcb;
		} while (p_tcb->p_lastcntcb != NULL);
	}
}
#endif /* TOPPERS_cancel_taskcounters */

/*
 *  Υԥåֵ
 */
#ifdef TOPPERS_release_taskspinlocks

void
release_taskspinlocks(TCB *p_tcb)
{
	SPNCB *p_spncb;

	p_spncb = p_tcb->p_lastspncb;

	/* OS߶ػ߾ְʾϤ */
	if (p_spncb != NULL) {
		do {
			acquire_spn_lock(GET_SPNLOCK());

			p_spncb->p_ccb = NULL;
			p_tcb->p_lastspncb = p_spncb->p_prevspncb;
			p_spncb->p_holdcb = NULL;

			release_spn_lock(GET_SPNLOCK());

			if (p_spncb->p_spninib->resint != NULL) {
				p_spncb->p_spninib->resint();
			}
			p_spncb = p_tcb->p_lastspncb;
		} while (p_spncb != NULL);
	}
}

#endif /* TOPPERS_release_taskspinlocks */

/*
 *  λݸ
 *  TerminateTask()ChainTask()ʤǤμνλ
 * ʥδؿ꥿ˤν
 */
#ifdef TOPPERS_exit_task

void
exit_task(void)
{
	CCB *p_ccb = get_my_p_ccb();

	x_nested_lock_os_int();

	/* ԥåޤޤξϥԥå */
	release_taskspinlocks(p_ccb->p_runtsk);

	/* ߶ػ߾֤ξϳ߶ػߤ */
	release_interrupts(OSServiceId_Invalid);

	/* ꥽ݤޤޤξϥ꥽ */
	release_taskresources(p_ccb->p_runtsk);

#ifdef CFG_USE_ERRORHOOK
	/* 顼եåƤ */
	call_errorhook(E_OS_MISSINGEND, OSServiceId_TaskMissingEnd);
#endif /* CFG_USE_ERRORHOOK */

	acquire_tsk_lock(p_ccb);
	suspend(p_ccb);
	release_tsk_lock(p_ccb);

	/* ݥȥեåͭʾϥݥȥեåƤФ */
	exit_and_dispatch();
}

#endif /* TOPPERS_exit_task */

#ifdef TOPPERS_remove_task_from_queue

/*
 *  ǥ塼饿
 */
void
remove_task_from_queue(TCB *p_tcb, PriorityType remove_task_pri)
{
	CCB *p_ccb = get_my_p_ccb();

	queue_delete(&(p_tcb->task_queue));
	if (queue_empty(&(p_ccb->ready_queue[remove_task_pri])) != FALSE) {
		primap_clear(p_ccb, remove_task_pri);
		p_ccb->nextpri = (primap_empty(p_ccb) != FALSE) ?	TPRI_MINTASK : primap_search(p_ccb);
	}
}

#endif /* TOPPERS_remove_task_from_queue */

#ifdef TOPPERS_suspend_ready_task

/*
 *  ǥ塼äƤ륿ٻ߾֤ˤ
 */
void
suspend_ready_task(TCB *p_tcb, PriorityType remove_task_pri)
{
	p_tcb->tstat = SUSPENDED;
	LOG_TSKSTAT(p_tcb);
	remove_task_from_queue(p_tcb, remove_task_pri);
	if (p_tcb->actcnt > 0U) {
		p_tcb->actcnt -= 1U;
		(void) make_active(p_tcb);
	}
}

#endif /* TOPPERS_suspend_ready_task */

/*
 *  ζλ
 *    ProtectionHook TeminateApplication Τ߸ƽФ
 *      ꥽β߶ػߤβԤä
 *       TerminateTaskνԤ
 *      λξϡPostTaskHookƽФʤΤTerminateTask
 *      ȤϰۤʤȤʤ
 *  ܴؿOS߶ػ߾֤ǸƽФ뤳ȤȤ
 */
#ifdef TOPPERS_force_terminate_task

void
force_terminate_task(TCB *p_tcb, StatusType terminate_cause, boolean term_osap_flag)
{
	/* curpriinipriۤʤͤǥǥ塼˷ҤƤؤб */
	CCB				*p_ccb = p_tcb->p_tinib->p_ccb;
	PriorityType	remove_task_pri = p_tcb->curpri;

	/* ԥåޤޤξϥԥå */
	release_taskspinlocks(p_tcb);

	/*
	 *  ߶ػߤ
	 *  顼եåƤФʤᡤOSServiceId_Invalid򤹤
	 */
	release_interrupts(OSServiceId_Invalid);

	/* ꥽ݤޤޤξ硤꥽ */
	release_taskresources(p_tcb);
	/* 󥿤֤˥å */
	cancel_taskcounters(p_tcb);

	if ((terminate_cause & PEOB_STACKMONITORING_TERMTASK) == 0U) {
		acquire_tsk_lock(p_ccb);
		/* TerminateTaskChainTaskΥǥѥåǤΥå˥󥰰ʳ */
		if ((p_tcb == p_ccb->p_runtsk) && (p_ccb->p_runtsk == p_ccb->p_schedtsk)) {

			/* ¹楿CPU㳰, ȯΥå˥, ؿλΥå˥ */
			suspend(p_ccb);
		}
		else {
			if (p_tcb == p_ccb->p_schedtsk) {
				/*
				 *  ˥ǥ塼鳰Ƥ륿νλ
				 *  p_schedtsk/p_tcbξ֤ѹ˼¹Ԥ٤õ
				 */
				p_tcb->tstat = SUSPENDED;
				search_schedtsk(p_ccb);
			}
			else {
				/*
				 *  curpriinipriۤʤͤǥǥ塼˷ҤƤؤ
				 *  бǡ꥽ͥ٤ѤоݥSUSPEND֤Ȥ
				 *  ǥ塼롥
				 */
				suspend_ready_task(p_tcb, remove_task_pri);
			}
		}
		release_tsk_lock(p_ccb);
	}

	if (term_osap_flag != FALSE) {
		/*
		 *  OSAPλ/ƵưθƤӽФ
		 *  »ܤ٤ʤ
		 */
	}
	else if (((terminate_cause & (~PROTECTION_ERROR_OPTIONAL_BIT)) == E_OS_STACKFAULT) &&
			 ((terminate_cause & (PROTECTION_ERROR_OPTIONAL_BIT)) != 0U)) {
		/*
		 *  ǥѥå㡤ǤΥå˥
		 *  ؿλΥå˥󥰤else¦
		 *  ¹Υϥǥѥå㤬ưޤǤʤ
		 */
		p_ccb->p_runtsk = NULL;
	}
	else {
		/* ߶ػ߾֤ǡλƤ⡤DisableAllInterrupts߶ػ߾֤ʤ */
		p_ccb->callevel_stat = (p_ccb->callevel_stat & TSYS_DISALLINT) | TCL_TASK;
		x_clear_nested_os_int();

		exit_and_dispatch_nohook();
	}
}

#endif /* TOPPERS_force_terminate_task */


/*
 *  OSAP°륿ζλ
 */
#ifdef TOPPERS_force_term_osap_task

void
force_term_osap_task(OSAPCB *p_osapcb)
{
	/* OSAP˽°륿λ */
	TaskType	i;
	TCB			*p_tcb;

	for (i = 0U; i < tnum_task; i++) {
		if (tinib_table[i].p_osapcb == p_osapcb) {
			p_tcb = p_tcb_table[i];
			/*
			 *  OSAPλ/Ƶư꥿ζλ
			 */
			p_tcb->actcnt = 0U;
			p_tcb->curevt = 0U;
#ifdef CFG_USE_PROTECTIONHOOK
			p_tcb->calltfn = FALSE;
#endif /* CFG_USE_PROTECTIONHOOK */
			if (p_tcb->tstat == READY) {
				force_terminate_task(p_tcb, 0U, TRUE);
			}
			else {
				p_tcb->tstat = SUSPENDED;
			}

			/*
			 *  Ǥϳ߶ػߤʤ
			 *  ˤޤǤδ֤ˡp_runtskλ졤p_schedtsk
			 *  Ƥ硤ߤATK2߷פǤϡߥϥɥ
			 *  νиǡp_runtsk != p_schedtskˤǥѥå
			 *  ȽԤäƤ뤿ᡤOSAPζˡ¾
			 *  ˥ǥѥåƤޤ
			 *  C2ISRΥ쥹ݥǽ夹뤿ᡤߤβ/ػߤ
			 *  λ˼»ܤ߷פͤ뤬
			 *  ATK2θߤΥǥѥå߷פѹɬפ
			 */

		}
	}
}

#endif /* TOPPERS_force_term_osap_task */
