/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2011-2015 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011-2015 by FUJI SOFT INCORPORATED, JAPAN
 *  Copyright (C) 2011-2013 by Spansion LLC, USA
 *  Copyright (C) 2011-2015 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2011-2015 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2011-2014 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2011-2015 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2011-2015 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2011-2015 by Witz Corporation
 *  Copyright (C) 2014-2015 by AISIN COMCRUISE Co., Ltd., JAPAN
 *  Copyright (C) 2014-2015 by eSOL Co.,Ltd., JAPAN
 *  Copyright (C) 2014-2015 by SCSK Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: nios2_system.h 1801 2015-03-27 06:34:43Z t_ishikawa $
 */

/*
 *		Nios2ƥ
 *
 *  ڥեΥɥ쥹ֹ
 */

#ifndef TOPPERS_NIOS2_SYSTEM_H
#define TOPPERS_NIOS2_SYSTEM_H

/*
 *  ޥå
 *  BG_CODE_START Ƭɥ쥹
 *  BG_CODE_END   ɽüɥ쥹
 *  BG_DATA_START ǡƬɥ쥹
 *  BG_DATA_END   ǡüɥ쥹
 */

#define BG_CODE_START	UINT_C(0x00000000)
#define BG_CODE_END		UINT_C(0xffffffff)
#define BG_DATA_START	UINT_C(0x00000000)
#define BG_DATA_END		UINT_C(0xffffffff)

#ifdef TOPPERS_NIOS2_DEV_DE2_115

/*
 *  NIOS2_DEV_DE2_115 Ѥ
 */

/*
 *  ưåΥåȥƥ̾
 */
#define TARGET_NAME	"NIOS2_DEV_DE2_115(NIOS2)"

/*
 *  ͤɽȥߥñ̤ȤѴ
 */
#define TIMER_CLOCK		UINT_C(60000)

/*
 *  ޥåפ
 */
#define RESET_START_ADDRESS		UINT_C(0x08000000)
#define RESET_SIZE				UINT_C(0x00000020)
#define EXCEPT_START_ADDRESS	UINT_C(0x08000020)
#define EXCEPT_SIZE				UINT_C(0x00000fe0)
#define ONCHIP0_START_ADDRESS	UINT_C(0x02080000)
#define ONCHIP1_START_ADDRESS	UINT_C(0x02180000)

#ifdef PLACE_SDRAM
#define ONCHIP0_SIZE			UINT_C(0x00020000)
#define ONCHIP1_SIZE			UINT_C(0x00020000)
#define ROM_START_ADDRESS		UINT_C(0x00001020)
#define ROM_SIZE				UINT_C(0x00ffefe0)
#define RAM_START_ADDRESS		UINT_C(0x01000000)
#define RAM_SIZE				UINT_C(0x01000000)
#else /* PLACE_SDRAM */
#define ONCHIP0_SIZE			UINT_C(0x00001000)
#define ONCHIP1_SIZE			UINT_C(0x00006000)
#define ROM_START_ADDRESS		UINT_C(0x02081000)
#define ROM_SIZE				UINT_C(0x0001F000)
#define RAM_START_ADDRESS		UINT_C(0x02186000)
#define RAM_SIZE				UINT_C(0x0001a000)
#endif /* PLACE_SDRAM */

/*
 *  å奵
 */
#define NIOS2_ICACHE_SIZE			UINT_C(0x1000)   /* 4Kbyte */
#define NIOS2_ICACHE_LINE_SIZE		UINT_C(32)
#define NIOS2_DCACHE_SIZE			UINT_C(0)
#define NIOS2_DCACHE_LINE_SIZE		UINT_C(0)


/*
 *  ڥեΥ١ɥ쥹
 */
#define CORE0_PERI_BASEADDR	UINT_C(0x02000000)
#define CORE1_PERI_BASEADDR	UINT_C(0x02100000)
#define CORE2_PERI_BASEADDR	UINT_C(0x02200000)
#define CORE3_PERI_BASEADDR	UINT_C(0x02300000)


/*
 *  Interval Timer
 */
#define SYS_CLK_TIMER_0_BASE	(UINT_C(0x00000800) + CORE0_PERI_BASEADDR)
#define SYS_CLK_TIMER_1_BASE	(UINT_C(0x00000800) + CORE1_PERI_BASEADDR)
#define SYS_CLK_TIMER_2_BASE	(UINT_C(0x00000800) + CORE2_PERI_BASEADDR)
#define SYS_CLK_TIMER_3_BASE	(UINT_C(0x00000800) + CORE3_PERI_BASEADDR)

#define SYS_CLK_TIMER_0_INT	UINT_C(0)
#define SYS_CLK_TIMER_1_INT	UINT_C(0)
#define SYS_CLK_TIMER_2_INT	UINT_C(0)
#define SYS_CLK_TIMER_3_INT	UINT_C(0)

/*
 *  JTAG UART
 */
#define JTAG_UART_PORT0_BASE	(UINT_C(0x00000820) + CORE0_PERI_BASEADDR)
#define JTAG_UART_PORT1_BASE	(UINT_C(0x00000820) + CORE1_PERI_BASEADDR)
#define JTAG_UART_PORT2_BASE	(UINT_C(0x00000820) + CORE2_PERI_BASEADDR)
#define JTAG_UART_PORT3_BASE	(UINT_C(0x00000820) + CORE3_PERI_BASEADDR)

#define JTAG_UART_PORT0_INT	UINT_C(1)
#define JTAG_UART_PORT1_INT	UINT_C(1)
#define JTAG_UART_PORT2_INT	UINT_C(1)
#define JTAG_UART_PORT3_INT	UINT_C(1)

/*
 *  UART
 */
#define UART_PORT0_BASE	(UINT_C(0x00000d00) + CORE0_PERI_BASEADDR)
#define UART_PORT1_BASE	(UINT_C(0x00000d00) + CORE1_PERI_BASEADDR)
#define UART_PORT2_BASE	(UINT_C(0x00000d00) + CORE2_PERI_BASEADDR)
#define UART_PORT3_BASE	(UINT_C(0x00000d00) + CORE3_PERI_BASEADDR)

#define UART_PORT0_INT	UINT_C(3)
#define UART_PORT1_INT	UINT_C(3)
#define UART_PORT2_INT	UINT_C(3)
#define UART_PORT3_INT	UINT_C(3)

/*
 *  ٥ߥȥ
 */
#define VIC_0_BASE				(UINT_C(0x00001000) + CORE0_PERI_BASEADDR)
#define VIC_1_BASE				(UINT_C(0x00001000) + CORE1_PERI_BASEADDR)
#define VIC_2_BASE				(UINT_C(0x00001000) + CORE2_PERI_BASEADDR)
#define VIC_3_BASE				(UINT_C(0x00001000) + CORE3_PERI_BASEADDR)

#define VIC_0_INT_NUM			UINT_C(32)
#define VIC_1_INT_NUM			UINT_C(32)
#define VIC_2_INT_NUM			UINT_C(32)
#define VIC_3_INT_NUM			UINT_C(32)

/*
 *  ƥС쥸Υ١ɥ쥹
 */
#define SYSVER_BASE				UINT_C(0x08100000)

/*
 *  ƥС󻲾
 */
#define TNUM_HWCORE				UINT_C(2)           /*  */
#define MAJOR_VAR				UINT_C(7)           /* ᥸㡼С */

/*
 * Nios2 MPU 
 */
#define NIOS2_MPU_INST_MAX_NUM	UINT_C(16)
#define NIOS2_MPU_DATA_MAX_NUM	UINT_C(16)

/*
 *  Mutex
 */
#define TSK_MUTEX_0_BASE		(UINT_C(0x00000c10) + CORE0_PERI_BASEADDR)
#define CNT_MUTEX_0_BASE		(UINT_C(0x00000c20) + CORE0_PERI_BASEADDR)
#define TSK_MUTEX_1_BASE		(UINT_C(0x00000c10) + CORE1_PERI_BASEADDR)
#define CNT_MUTEX_1_BASE		(UINT_C(0x00000c20) + CORE1_PERI_BASEADDR)
#define TSK_MUTEX_2_BASE		(UINT_C(0x00000c10) + CORE2_PERI_BASEADDR)
#define CNT_MUTEX_2_BASE		(UINT_C(0x00000c20) + CORE2_PERI_BASEADDR)
#define TSK_MUTEX_3_BASE		(UINT_C(0x00000c10) + CORE3_PERI_BASEADDR)
#define CNT_MUTEX_3_BASE		(UINT_C(0x00000c20) + CORE3_PERI_BASEADDR)

#define SPN_MUTEX_BASE			(0x08200000)
#define IOC_MUTEX_BASE			(0x08200010)
#define SIL_MUTEX_BASE			(0x08200020)


/*
 * ֳHW
 */
#define CORE_INT_0_BASE	(UINT_C(0x00000c00) + CORE0_PERI_BASEADDR)
#define CORE_INT_1_BASE	(UINT_C(0x00000c00) + CORE1_PERI_BASEADDR)
#define CORE_INT_2_BASE	(UINT_C(0x00000c00) + CORE2_PERI_BASEADDR)
#define CORE_INT_3_BASE	(UINT_C(0x00000c00) + CORE3_PERI_BASEADDR)

#define CORE_INT_0_INT	UINT_C(2)
#define CORE_INT_1_INT	UINT_C(2)
#define CORE_INT_2_INT	UINT_C(2)
#define CORE_INT_3_INT	UINT_C(2)

#endif /* TOPPERS_NIOS2_DEV_DE2_115 */

/*
 *  ƥС쥸(sysver)
 */
#define SYSVER_MAJOR_VAR	(SYSVER_BASE + 0x00U)
#define SYSVER_MINOR_VAR	(SYSVER_BASE + 0x04U)
#define SYSVER_NUM_CORE		(SYSVER_BASE + 0x08U)

#endif /* TOPPERS_NIOS2_SYSTEM_H */
