/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2008-2015 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011-2015 by FUJI SOFT INCORPORATED, JAPAN
 *  Copyright (C) 2011-2013 by Spansion LLC, USA
 *  Copyright (C) 2011-2015 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2011-2015 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2011-2014 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2011-2015 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2011-2015 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2011-2015 by Witz Corporation
 *  Copyright (C) 2014-2015 by AISIN COMCRUISE Co., Ltd., JAPAN
 *  Copyright (C) 2014-2015 by eSOL Co.,Ltd., JAPAN
 *  Copyright (C) 2014-2015 by SCSK Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: target_hw_counter.h 1801 2015-03-27 06:34:43Z t_ishikawa $
 */

/*
 *		ƥȥץΥåȰ¸NIOS2_DEVѡ
 */

#ifndef TOPPERS_TARGET_HW_COUNTER_H
#define TOPPERS_TARGET_HW_COUNTER_H

/*
 *  󥿺
 */
#define MAX_TIMER_CNT		((uint32) 0xFFFFFFFF)

/*
 *  󥿼
 */
#define MAX_CNT_CYCLE		((uint32) 0x7FFFFFFF)

/*
 *  ޥϡɥ¸Υ١
 */
#ifdef TOPPERS_NIOS2_DEV_DE2_115

/*
 *  ޡåȿHz60MHz
 */
#define TIMER_CLOCK_HZ		((uint32) 60000000)


/*
 *  NIOS2_DEV_DE2_115 ѤBASE ADDRESS
 */
#define INTNO_BASE_CORE0	UINT_C(0x10000)
#define INTNO_BASE_CORE1	UINT_C(0x20000)

/*
 *  NIOS2_DEV_DE2_115 Ѥֹ
 */
#define TIMER_0_IRQ			UINT_C(16)
#define TIMER_1_IRQ			UINT_C(17)
#define TIMER_2_IRQ			UINT_C(18)
#define TIMER_3_IRQ			UINT_C(19)
#define TIMER_4_IRQ			UINT_C(20)
#define TIMER_5_IRQ			UINT_C(21)
#define TIMER_6_IRQ			UINT_C(22)
#define TIMER_7_IRQ			UINT_C(23)
#define TIMER_8_IRQ			UINT_C(24)
#define TIMER_9_IRQ			UINT_C(25)
#define TIMER_10_IRQ		UINT_C(26)
#define TIMER_11_IRQ		UINT_C(27)
#define TIMER_12_IRQ		UINT_C(28)
#define TIMER_13_IRQ		UINT_C(29)
#define TIMER_14_IRQ		UINT_C(30)
#define TIMER_15_IRQ		UINT_C(31)

#define TIMER_CORE0_0_IRQ		UINT_C(16) + INTNO_BASE_CORE0
#define TIMER_CORE0_1_IRQ		UINT_C(17) + INTNO_BASE_CORE0
#define TIMER_CORE0_2_IRQ		UINT_C(18) + INTNO_BASE_CORE0
#define TIMER_CORE0_3_IRQ		UINT_C(19) + INTNO_BASE_CORE0
#define TIMER_CORE0_4_IRQ		UINT_C(20) + INTNO_BASE_CORE0
#define TIMER_CORE0_5_IRQ		UINT_C(21) + INTNO_BASE_CORE0
#define TIMER_CORE0_6_IRQ		UINT_C(22) + INTNO_BASE_CORE0
#define TIMER_CORE0_7_IRQ		UINT_C(23) + INTNO_BASE_CORE0
#define TIMER_CORE0_8_IRQ		UINT_C(24) + INTNO_BASE_CORE0
#define TIMER_CORE0_9_IRQ		UINT_C(25) + INTNO_BASE_CORE0
#define TIMER_CORE0_10_IRQ		UINT_C(26) + INTNO_BASE_CORE0
#define TIMER_CORE0_11_IRQ		UINT_C(27) + INTNO_BASE_CORE0
#define TIMER_CORE0_12_IRQ		UINT_C(28) + INTNO_BASE_CORE0
#define TIMER_CORE0_13_IRQ		UINT_C(29) + INTNO_BASE_CORE0
#define TIMER_CORE0_14_IRQ		UINT_C(30) + INTNO_BASE_CORE0
#define TIMER_CORE0_15_IRQ		UINT_C(31) + INTNO_BASE_CORE0

#define TIMER_CORE1_0_IRQ		UINT_C(16) + INTNO_BASE_CORE1
#define TIMER_CORE1_1_IRQ		UINT_C(17) + INTNO_BASE_CORE1
#define TIMER_CORE1_2_IRQ		UINT_C(18) + INTNO_BASE_CORE1
#define TIMER_CORE1_3_IRQ		UINT_C(19) + INTNO_BASE_CORE1
#define TIMER_CORE1_4_IRQ		UINT_C(20) + INTNO_BASE_CORE1
#define TIMER_CORE1_5_IRQ		UINT_C(21) + INTNO_BASE_CORE1
#define TIMER_CORE1_6_IRQ		UINT_C(22) + INTNO_BASE_CORE1
#define TIMER_CORE1_7_IRQ		UINT_C(23) + INTNO_BASE_CORE1
#define TIMER_CORE1_8_IRQ		UINT_C(24) + INTNO_BASE_CORE1
#define TIMER_CORE1_9_IRQ		UINT_C(25) + INTNO_BASE_CORE1
#define TIMER_CORE1_10_IRQ		UINT_C(26) + INTNO_BASE_CORE1
#define TIMER_CORE1_11_IRQ		UINT_C(27) + INTNO_BASE_CORE1
#define TIMER_CORE1_12_IRQ		UINT_C(28) + INTNO_BASE_CORE1
#define TIMER_CORE1_13_IRQ		UINT_C(29) + INTNO_BASE_CORE1
#define TIMER_CORE1_14_IRQ		UINT_C(30) + INTNO_BASE_CORE1
#define TIMER_CORE1_15_IRQ		UINT_C(31) + INTNO_BASE_CORE1

/*
 *  NIOS2_DEV_DE2_115 Ѥޥ쥸١
 */
#define TIMER_BASE(INTNO)     (UINT_C(0x0c000200) +											  \
							   (UINT_C(0x00100000) * (((INTNO) >> UINT_C(16)) - UINT_C(1))) + \
							   (UINT_C(0x20) * (((INTNO) &UINT_C(0xffff)) - UINT_C(16))))

/* ʳΥå */
#endif /* TOPPERS_NIOS2_DEV_DE2_115 */

/*
 *  control쥸Υӥå
 */
#define TIMER_CONTROL_ITO		(UINT_C(0x00000001))
#define TIMER_CONTROL_CONT		(UINT_C(0x00000002))
#define TIMER_CONTROL_START		(UINT_C(0x00000004))
#define TIMER_CONTROL_STOP		(UINT_C(0x00000008))

/*
 *  TIMERϢ쥸
 */
#define TIMER_STATUS(INTNO)		(TIMER_BASE(INTNO) + UINT_C(0x00000000))
#define TIMER_CONTROL(INTNO)	(TIMER_BASE(INTNO) + UINT_C(0x00000004))
#define TIMER_PERIODL(INTNO)	(TIMER_BASE(INTNO) + UINT_C(0x00000008))
#define TIMER_PERIODH(INTNO)	(TIMER_BASE(INTNO) + UINT_C(0x0000000C))
#define TIMER_SNAPL(INTNO)		(TIMER_BASE(INTNO) + UINT_C(0x00000010))
#define TIMER_SNAPH(INTNO)		(TIMER_BASE(INTNO) + UINT_C(0x00000014))

/* MAIN_HW_COUNTER_CORE0 */
extern void init_hwcounter_MAIN_HW_COUNTER_CORE0(TickType maxval, TimeType nspertick);
extern void start_hwcounter_MAIN_HW_COUNTER_CORE0(void);
extern void stop_hwcounter_MAIN_HW_COUNTER_CORE0(void);
extern void set_hwcounter_MAIN_HW_COUNTER_CORE0(TickType exprtick);
extern TickType get_hwcounter_MAIN_HW_COUNTER_CORE0(void);
extern void cancel_hwcounter_MAIN_HW_COUNTER_CORE0(void);
extern void trigger_hwcounter_MAIN_HW_COUNTER_CORE0(void);
extern void int_clear_hwcounter_MAIN_HW_COUNTER_CORE0(void);
extern void int_cancel_hwcounter_MAIN_HW_COUNTER_CORE0(void);
extern void increment_hwcounter_MAIN_HW_COUNTER_CORE0(void);

/* MAIN_HW_COUNTER_CORE1 */
extern void init_hwcounter_MAIN_HW_COUNTER_CORE1(TickType maxval, TimeType nspertick);
extern void start_hwcounter_MAIN_HW_COUNTER_CORE1(void);
extern void stop_hwcounter_MAIN_HW_COUNTER_CORE1(void);
extern void set_hwcounter_MAIN_HW_COUNTER_CORE1(TickType exprtick);
extern TickType get_hwcounter_MAIN_HW_COUNTER_CORE1(void);
extern void cancel_hwcounter_MAIN_HW_COUNTER_CORE1(void);
extern void trigger_hwcounter_MAIN_HW_COUNTER_CORE1(void);
extern void int_clear_hwcounter_MAIN_HW_COUNTER_CORE1(void);
extern void int_cancel_hwcounter_MAIN_HW_COUNTER_CORE1(void);
extern void increment_hwcounter_MAIN_HW_COUNTER_CORE1(void);

/*
 *  10msȰפƥå(ץץ)
 */
#define TICK_FOR_10MS	TIMER_CLOCK_HZ / 100

#endif /* TOPPERS_TARGET_HW_COUNTER_H */
